/* PlaybackManager.c generated by valac 0.56.17, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2022 elementary, Inc. (https://elementary.io)
 */

#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gst/gst.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <granite-7.h>

#define AUDIENCE_APP_ACTION_PLAY_PAUSE "action-play-pause"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define AUDIENCE_TYPE_PLAYBACK_MANAGER (audience_playback_manager_get_type ())
#define AUDIENCE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManager))
#define AUDIENCE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManagerClass))
#define AUDIENCE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_PLAYBACK_MANAGER))
#define AUDIENCE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_PLAYBACK_MANAGER))
#define AUDIENCE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManagerClass))

typedef struct _AudiencePlaybackManager AudiencePlaybackManager;
typedef struct _AudiencePlaybackManagerClass AudiencePlaybackManagerClass;
typedef struct _AudiencePlaybackManagerPrivate AudiencePlaybackManagerPrivate;
enum  {
	AUDIENCE_PLAYBACK_MANAGER_0_PROPERTY,
	AUDIENCE_PLAYBACK_MANAGER_GST_VIDEO_WIDGET_PROPERTY,
	AUDIENCE_PLAYBACK_MANAGER_SUBTITLE_URI_PROPERTY,
	AUDIENCE_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	AUDIENCE_PLAYBACK_MANAGER_DURATION_PROPERTY,
	AUDIENCE_PLAYBACK_MANAGER_POSITION_PROPERTY,
	AUDIENCE_PLAYBACK_MANAGER_PLAY_QUEUE_PROPERTY,
	AUDIENCE_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_NUM_PROPERTIES];
typedef enum  {
	AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_DISABLED,
	AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ALL,
	AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ONE
} AudiencePlaybackManagerRepeatMode;

#define AUDIENCE_PLAYBACK_MANAGER_TYPE_REPEAT_MODE (audience_playback_manager_repeat_mode_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define AUDIENCE_TYPE_UNSUPPORTED_FILE_DIALOG (audience_unsupported_file_dialog_get_type ())
#define AUDIENCE_UNSUPPORTED_FILE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_UNSUPPORTED_FILE_DIALOG, AudienceUnsupportedFileDialog))
#define AUDIENCE_UNSUPPORTED_FILE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_UNSUPPORTED_FILE_DIALOG, AudienceUnsupportedFileDialogClass))
#define AUDIENCE_IS_UNSUPPORTED_FILE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_UNSUPPORTED_FILE_DIALOG))
#define AUDIENCE_IS_UNSUPPORTED_FILE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_UNSUPPORTED_FILE_DIALOG))
#define AUDIENCE_UNSUPPORTED_FILE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_UNSUPPORTED_FILE_DIALOG, AudienceUnsupportedFileDialogClass))

typedef struct _AudienceUnsupportedFileDialog AudienceUnsupportedFileDialog;
typedef struct _AudienceUnsupportedFileDialogClass AudienceUnsupportedFileDialogClass;
typedef struct _Block8Data Block8Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	AUDIENCE_PLAYBACK_MANAGER_ENDED_SIGNAL,
	AUDIENCE_PLAYBACK_MANAGER_NEXT_AUDIO_SIGNAL,
	AUDIENCE_PLAYBACK_MANAGER_NEXT_TEXT_SIGNAL,
	AUDIENCE_PLAYBACK_MANAGER_URI_CHANGED_SIGNAL,
	AUDIENCE_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _AudiencePlaybackManager {
	GObject parent_instance;
	AudiencePlaybackManagerPrivate * priv;
};

struct _AudiencePlaybackManagerClass {
	GObjectClass parent_class;
};

struct _AudiencePlaybackManagerPrivate {
	GdkPaintable* _gst_video_widget;
	gchar* _subtitle_uri;
	gboolean _playing;
	gint64 _duration;
	gint64 _position;
	GtkStringList* _play_queue;
	GstElement* playbin;
	gboolean is_seeking;
	gint64 queued_seek;
	guint inhibit_token;
};

struct _Block8Data {
	int _ref_count_;
	AudiencePlaybackManager* self;
	AudienceUnsupportedFileDialog* unsupported_file_dialog;
};

struct _Block9Data {
	int _ref_count_;
	AudiencePlaybackManager* self;
	gboolean temp_playing;
	gint64 temp_position;
	gulong ready_handler_id;
};

struct _Block10Data {
	int _ref_count_;
	AudiencePlaybackManager* self;
	GtkApplication* default_application;
};

static gint AudiencePlaybackManager_private_offset;
static gpointer audience_playback_manager_parent_class = NULL;
VALA_EXTERN GSettings* audience_settings;
static GOnce audience_playback_manager_instance;
static GOnce audience_playback_manager_instance = G_ONCE_INIT;

VALA_EXTERN GType audience_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudiencePlaybackManager, g_object_unref)
VALA_EXTERN gint64 audience_playback_manager_get_duration (AudiencePlaybackManager* self);
VALA_EXTERN gint64 audience_playback_manager_get_position (AudiencePlaybackManager* self);
VALA_EXTERN GType audience_playback_manager_repeat_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AudiencePlaybackManager* audience_playback_manager_get_default (void);
static AudiencePlaybackManager* __lambda10_ (void);
VALA_EXTERN AudiencePlaybackManager* audience_playback_manager_new (void);
VALA_EXTERN AudiencePlaybackManager* audience_playback_manager_construct (GType object_type);
static gpointer ___lambda10__gthread_func (gpointer self);
static void audience_playback_manager_handle_bus_message (AudiencePlaybackManager* self,
                                                   GstMessage* message);
VALA_EXTERN void audience_playback_manager_play_file (AudiencePlaybackManager* self,
                                          const gchar* uri,
                                          gboolean from_beginning);
VALA_EXTERN gboolean audience_playback_manager_next (AudiencePlaybackManager* self);
VALA_EXTERN GtkStringList* audience_playback_manager_get_play_queue (AudiencePlaybackManager* self);
static void audience_playback_manager_set_position (AudiencePlaybackManager* self,
                                             gint64 value);
static void audience_playback_manager_set_duration (AudiencePlaybackManager* self,
                                             gint64 value);
static void audience_playback_manager_set_playing (AudiencePlaybackManager* self,
                                            gboolean value);
VALA_EXTERN void audience_playback_manager_seek (AudiencePlaybackManager* self,
                                     gint64 position);
VALA_EXTERN gboolean audience_playback_manager_get_playing (AudiencePlaybackManager* self);
static void audience_playback_manager_update_position (AudiencePlaybackManager* self);
VALA_EXTERN GType audience_unsupported_file_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceUnsupportedFileDialog, g_object_unref)
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
VALA_EXTERN AudienceUnsupportedFileDialog* audience_unsupported_file_dialog_new (const gchar* uri,
                                                                     const gchar* filename,
                                                                     const gchar* content_type);
VALA_EXTERN AudienceUnsupportedFileDialog* audience_unsupported_file_dialog_construct (GType object_type,
                                                                           const gchar* uri,
                                                                           const gchar* filename,
                                                                           const gchar* content_type);
static void ____lambda11_ (Block8Data* _data8_,
                    gint type);
static void _____lambda11__gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self);
VALA_EXTERN void audience_playback_manager_set_subtitle (AudiencePlaybackManager* self,
                                             const gchar* uri);
static gchar* audience_playback_manager_get_subtitle_for_uri (AudiencePlaybackManager* self,
                                                       const gchar* uri);
VALA_EXTERN void audience_playback_manager_stop (AudiencePlaybackManager* self);
VALA_EXTERN void audience_playback_manager_clear_playlist (AudiencePlaybackManager* self,
                                               gboolean should_stop);
VALA_EXTERN void audience_playback_manager_append_to_playlist (AudiencePlaybackManager* self,
                                                   gchar** uris,
                                                   gint uris_length1);
static gboolean audience_playback_manager_is_subtitle (AudiencePlaybackManager* self,
                                                const gchar* uri);
static void audience_playback_manager_set_subtitle_uri (AudiencePlaybackManager* self,
                                                 const gchar* value);
static guint audience_playback_manager_get_queue_position (AudiencePlaybackManager* self,
                                                    const gchar* uri);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void audience_playback_manager_save_playlist (AudiencePlaybackManager* self);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void audience_playback_manager_previous (AudiencePlaybackManager* self);
VALA_EXTERN GList* audience_playback_manager_get_audio_tracks (AudiencePlaybackManager* self);
VALA_EXTERN GList* audience_playback_manager_get_subtitle_tracks (AudiencePlaybackManager* self);
VALA_EXTERN gchar* audience_playback_manager_get_uri (AudiencePlaybackManager* self);
VALA_EXTERN gint audience_playback_manager_get_audio_track (AudiencePlaybackManager* self);
VALA_EXTERN void audience_playback_manager_set_audio_track (AudiencePlaybackManager* self,
                                                gint track);
VALA_EXTERN gint audience_playback_manager_get_subtitle_track (AudiencePlaybackManager* self);
VALA_EXTERN void audience_playback_manager_set_subtitle_track (AudiencePlaybackManager* self,
                                                   gint track);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void ___lambda12_ (Block9Data* _data9_);
static void ____lambda12__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
VALA_EXTERN GdkPaintable* audience_playback_manager_get_gst_video_widget (AudiencePlaybackManager* self);
static void audience_playback_manager_set_gst_video_widget (AudiencePlaybackManager* self,
                                                     GdkPaintable* value);
VALA_EXTERN const gchar* audience_playback_manager_get_subtitle_uri (AudiencePlaybackManager* self);
static void audience_playback_manager_set_play_queue (AudiencePlaybackManager* self,
                                               GtkStringList* value);
static GObject * audience_playback_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void _audience_playback_manager_handle_bus_message_gst_bus_message (GstBus* _sender,
                                                                    GstMessage* message,
                                                                    gpointer self);
static void _audience_playback_manager___lambda13_ (AudiencePlaybackManager* self);
static void __audience_playback_manager___lambda13__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void _audience_playback_manager___lambda14_ (AudiencePlaybackManager* self);
static void __audience_playback_manager___lambda14__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void _audience_playback_manager___lambda15_ (AudiencePlaybackManager* self,
                                             const gchar* name,
                                             GVariant* new_state);
static void __audience_playback_manager___lambda15__g_action_group_action_state_changed (GActionGroup* _sender,
                                                                                  const gchar* action_name,
                                                                                  GVariant* state,
                                                                                  gpointer self);
static void _audience_playback_manager_save_playlist_g_list_model_items_changed (GListModel* _sender,
                                                                          guint position,
                                                                          guint removed,
                                                                          guint added,
                                                                          gpointer self);
static void _audience_playback_manager___lambda16_ (Block10Data* _data10_);
static GVariant* _variant_new11 (gboolean value);
static void __audience_playback_manager___lambda16__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static gboolean _audience_playback_manager___lambda17_ (AudiencePlaybackManager* self);
static gboolean __audience_playback_manager___lambda17__gsource_func (gpointer self);
static void audience_playback_manager_finalize (GObject * obj);
static GType audience_playback_manager_get_type_once (void);
static void _vala_audience_playback_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_audience_playback_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const gchar* AUDIENCE_SUBTITLE_EXTENSIONS[6];

static inline gpointer
audience_playback_manager_get_instance_private (AudiencePlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, AudiencePlaybackManager_private_offset);
}

static GType
audience_playback_manager_repeat_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_DISABLED, "AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_DISABLED", "disabled"}, {AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ALL, "AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ALL", "all"}, {AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ONE, "AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ONE", "one"}, {0, NULL, NULL}};
	GType audience_playback_manager_repeat_mode_type_id;
	audience_playback_manager_repeat_mode_type_id = g_enum_register_static ("AudiencePlaybackManagerRepeatMode", values);
	return audience_playback_manager_repeat_mode_type_id;
}

GType
audience_playback_manager_repeat_mode_get_type (void)
{
	static volatile gsize audience_playback_manager_repeat_mode_type_id__once = 0;
	if (g_once_init_enter (&audience_playback_manager_repeat_mode_type_id__once)) {
		GType audience_playback_manager_repeat_mode_type_id;
		audience_playback_manager_repeat_mode_type_id = audience_playback_manager_repeat_mode_get_type_once ();
		g_once_init_leave (&audience_playback_manager_repeat_mode_type_id__once, audience_playback_manager_repeat_mode_type_id);
	}
	return audience_playback_manager_repeat_mode_type_id__once;
}

static AudiencePlaybackManager*
__lambda10_ (void)
{
	AudiencePlaybackManager* _tmp0_;
	AudiencePlaybackManager* result;
#line 34 "../src/Services/PlaybackManager.vala"
	_tmp0_ = audience_playback_manager_new ();
#line 34 "../src/Services/PlaybackManager.vala"
	result = _tmp0_;
#line 34 "../src/Services/PlaybackManager.vala"
	return result;
#line 326 "PlaybackManager.c"
}

static gpointer
___lambda10__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda10_ ();
#line 34 "../src/Services/PlaybackManager.vala"
	return result;
#line 336 "PlaybackManager.c"
}

AudiencePlaybackManager*
audience_playback_manager_get_default (void)
{
	gconstpointer _tmp0_;
	AudiencePlaybackManager* result;
#line 34 "../src/Services/PlaybackManager.vala"
	_tmp0_ = g_once (&audience_playback_manager_instance, ___lambda10__gthread_func, NULL);
#line 34 "../src/Services/PlaybackManager.vala"
	result = (AudiencePlaybackManager*) _tmp0_;
#line 34 "../src/Services/PlaybackManager.vala"
	return result;
#line 350 "PlaybackManager.c"
}

static void
audience_playback_manager_handle_bus_message (AudiencePlaybackManager* self,
                                              GstMessage* message)
{
	GtkApplication* default_application = NULL;
	GApplication* _tmp0_;
#line 103 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (message != NULL);
#line 104 "../src/Services/PlaybackManager.vala"
	_tmp0_ = g_application_get_default ();
#line 104 "../src/Services/PlaybackManager.vala"
	default_application = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication);
#line 106 "../src/Services/PlaybackManager.vala"
	switch (message->type) {
#line 106 "../src/Services/PlaybackManager.vala"
		case GST_MESSAGE_EOS:
#line 371 "PlaybackManager.c"
		{
			AudiencePlaybackManagerRepeatMode repeat_mode = 0;
			GSettings* _tmp1_;
#line 108 "../src/Services/PlaybackManager.vala"
			_tmp1_ = audience_settings;
#line 108 "../src/Services/PlaybackManager.vala"
			repeat_mode = (AudiencePlaybackManagerRepeatMode) g_settings_get_enum (_tmp1_, "repeat-mode");
#line 109 "../src/Services/PlaybackManager.vala"
			if (repeat_mode == AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ONE) {
#line 381 "PlaybackManager.c"
				GstElement* _tmp2_;
				gchar* _tmp3_;
				const gchar* _tmp4_;
#line 110 "../src/Services/PlaybackManager.vala"
				_tmp2_ = self->priv->playbin;
#line 110 "../src/Services/PlaybackManager.vala"
				g_object_get (_tmp2_, "current-uri", &_tmp3_, NULL);
#line 110 "../src/Services/PlaybackManager.vala"
				_tmp4_ = _tmp3_;
#line 110 "../src/Services/PlaybackManager.vala"
				audience_playback_manager_play_file (self, _tmp4_, TRUE);
#line 393 "PlaybackManager.c"
			} else {
#line 111 "../src/Services/PlaybackManager.vala"
				if (!audience_playback_manager_next (self)) {
#line 112 "../src/Services/PlaybackManager.vala"
					if (repeat_mode == AUDIENCE_PLAYBACK_MANAGER_REPEAT_MODE_ALL) {
#line 399 "PlaybackManager.c"
						GtkStringList* _tmp5_;
						const gchar* _tmp6_;
#line 113 "../src/Services/PlaybackManager.vala"
						_tmp5_ = self->priv->_play_queue;
#line 113 "../src/Services/PlaybackManager.vala"
						_tmp6_ = gtk_string_list_get_string (_tmp5_, (guint) 0);
#line 113 "../src/Services/PlaybackManager.vala"
						audience_playback_manager_play_file (self, _tmp6_, TRUE);
#line 408 "PlaybackManager.c"
					} else {
						GstElement* _tmp7_;
						GSettings* _tmp8_;
#line 115 "../src/Services/PlaybackManager.vala"
						_tmp7_ = self->priv->playbin;
#line 115 "../src/Services/PlaybackManager.vala"
						gst_element_set_state (_tmp7_, GST_STATE_NULL);
#line 116 "../src/Services/PlaybackManager.vala"
						_tmp8_ = audience_settings;
#line 116 "../src/Services/PlaybackManager.vala"
						g_settings_set_int64 (_tmp8_, "last-stopped", (gint64) 0);
#line 117 "../src/Services/PlaybackManager.vala"
						audience_playback_manager_set_position (self, (gint64) 0);
#line 118 "../src/Services/PlaybackManager.vala"
						audience_playback_manager_set_duration (self, (gint64) 0);
#line 119 "../src/Services/PlaybackManager.vala"
						g_signal_emit (self, audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_ENDED_SIGNAL], 0);
#line 426 "PlaybackManager.c"
					}
				}
			}
#line 122 "../src/Services/PlaybackManager.vala"
			break;
#line 432 "PlaybackManager.c"
		}
#line 106 "../src/Services/PlaybackManager.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 436 "PlaybackManager.c"
		{
			GstState old_state = 0;
			GstState new_state = 0;
			GstState pending_state = 0;
			GstState _tmp9_ = 0;
			GstState _tmp10_ = 0;
			GstState _tmp11_ = 0;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp16_;
#line 129 "../src/Services/PlaybackManager.vala"
			gst_message_parse_state_changed (message, &_tmp9_, &_tmp10_, &_tmp11_);
#line 129 "../src/Services/PlaybackManager.vala"
			old_state = _tmp9_;
#line 129 "../src/Services/PlaybackManager.vala"
			new_state = _tmp10_;
#line 129 "../src/Services/PlaybackManager.vala"
			pending_state = _tmp11_;
#line 131 "../src/Services/PlaybackManager.vala"
			audience_playback_manager_set_playing (self, new_state == GST_STATE_PLAYING);
#line 133 "../src/Services/PlaybackManager.vala"
			if (old_state == GST_STATE_READY) {
#line 133 "../src/Services/PlaybackManager.vala"
				_tmp12_ = new_state == GST_STATE_PAUSED;
#line 460 "PlaybackManager.c"
			} else {
#line 133 "../src/Services/PlaybackManager.vala"
				_tmp12_ = FALSE;
#line 464 "PlaybackManager.c"
			}
#line 133 "../src/Services/PlaybackManager.vala"
			if (_tmp12_) {
#line 468 "PlaybackManager.c"
				gint64 _duration = 0LL;
				GstElement* _tmp13_;
				gint64 _tmp14_ = 0LL;
				gboolean _tmp15_;
#line 135 "../src/Services/PlaybackManager.vala"
				_tmp13_ = self->priv->playbin;
#line 135 "../src/Services/PlaybackManager.vala"
				_tmp15_ = gst_element_query_duration (_tmp13_, GST_FORMAT_TIME, &_tmp14_);
#line 135 "../src/Services/PlaybackManager.vala"
				_duration = _tmp14_;
#line 135 "../src/Services/PlaybackManager.vala"
				if (_tmp15_) {
#line 136 "../src/Services/PlaybackManager.vala"
					audience_playback_manager_set_duration (self, _duration);
#line 483 "PlaybackManager.c"
				}
#line 139 "../src/Services/PlaybackManager.vala"
				if (self->priv->queued_seek >= ((gint64) 0)) {
#line 140 "../src/Services/PlaybackManager.vala"
					audience_playback_manager_seek (self, self->priv->queued_seek);
#line 489 "PlaybackManager.c"
				}
			}
#line 144 "../src/Services/PlaybackManager.vala"
			_tmp16_ = self->priv->_playing;
#line 144 "../src/Services/PlaybackManager.vala"
			if (_tmp16_) {
#line 496 "PlaybackManager.c"
				GtkApplication* _tmp18_;
				GtkApplication* _tmp19_;
				GtkWindow* _tmp20_;
				GtkWindow* _tmp21_;
#line 145 "../src/Services/PlaybackManager.vala"
				if (self->priv->inhibit_token != ((guint) 0)) {
#line 503 "PlaybackManager.c"
					GtkApplication* _tmp17_;
#line 146 "../src/Services/PlaybackManager.vala"
					_tmp17_ = default_application;
#line 146 "../src/Services/PlaybackManager.vala"
					gtk_application_uninhibit (_tmp17_, self->priv->inhibit_token);
#line 509 "PlaybackManager.c"
				}
#line 149 "../src/Services/PlaybackManager.vala"
				_tmp18_ = default_application;
#line 149 "../src/Services/PlaybackManager.vala"
				_tmp19_ = default_application;
#line 149 "../src/Services/PlaybackManager.vala"
				_tmp20_ = gtk_application_get_active_window (_tmp19_);
#line 149 "../src/Services/PlaybackManager.vala"
				_tmp21_ = _tmp20_;
#line 149 "../src/Services/PlaybackManager.vala"
				self->priv->inhibit_token = gtk_application_inhibit (_tmp18_, _tmp21_, GTK_APPLICATION_INHIBIT_IDLE | GTK_APPLICATION_INHIBIT_SUSPEND, _ ("A video is playing"));
#line 521 "PlaybackManager.c"
			} else {
#line 154 "../src/Services/PlaybackManager.vala"
				if (self->priv->inhibit_token != ((guint) 0)) {
#line 525 "PlaybackManager.c"
					GtkApplication* _tmp22_;
#line 155 "../src/Services/PlaybackManager.vala"
					_tmp22_ = default_application;
#line 155 "../src/Services/PlaybackManager.vala"
					gtk_application_uninhibit (_tmp22_, self->priv->inhibit_token);
#line 156 "../src/Services/PlaybackManager.vala"
					self->priv->inhibit_token = (guint) 0;
#line 533 "PlaybackManager.c"
				}
			}
#line 158 "../src/Services/PlaybackManager.vala"
			break;
#line 538 "PlaybackManager.c"
		}
#line 106 "../src/Services/PlaybackManager.vala"
		case GST_MESSAGE_ASYNC_DONE:
#line 542 "PlaybackManager.c"
		{
#line 161 "../src/Services/PlaybackManager.vala"
			if (self->priv->is_seeking) {
#line 162 "../src/Services/PlaybackManager.vala"
				self->priv->is_seeking = FALSE;
#line 164 "../src/Services/PlaybackManager.vala"
				audience_playback_manager_update_position (self);
#line 166 "../src/Services/PlaybackManager.vala"
				if (self->priv->queued_seek >= ((gint64) 0)) {
#line 167 "../src/Services/PlaybackManager.vala"
					audience_playback_manager_seek (self, self->priv->queued_seek);
#line 554 "PlaybackManager.c"
				}
			}
#line 170 "../src/Services/PlaybackManager.vala"
			break;
#line 559 "PlaybackManager.c"
		}
		default:
		{
#line 173 "../src/Services/PlaybackManager.vala"
			break;
#line 565 "PlaybackManager.c"
		}
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 187 "../src/Services/PlaybackManager.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 187 "../src/Services/PlaybackManager.vala"
	return _data8_;
#line 577 "PlaybackManager.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 187 "../src/Services/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 587 "PlaybackManager.c"
		AudiencePlaybackManager* self;
#line 187 "../src/Services/PlaybackManager.vala"
		self = _data8_->self;
#line 187 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (_data8_->unsupported_file_dialog);
#line 187 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 187 "../src/Services/PlaybackManager.vala"
		g_slice_free (Block8Data, _data8_);
#line 597 "PlaybackManager.c"
	}
}

static void
____lambda11_ (Block8Data* _data8_,
               gint type)
{
	AudiencePlaybackManager* self;
	AudienceUnsupportedFileDialog* _tmp0_;
#line 192 "../src/Services/PlaybackManager.vala"
	self = _data8_->self;
#line 193 "../src/Services/PlaybackManager.vala"
	if (type == ((gint) GTK_RESPONSE_CANCEL)) {
#line 195 "../src/Services/PlaybackManager.vala"
		if (!audience_playback_manager_next (self)) {
#line 196 "../src/Services/PlaybackManager.vala"
			g_signal_emit (self, audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_ENDED_SIGNAL], 0);
#line 615 "PlaybackManager.c"
		}
	}
#line 200 "../src/Services/PlaybackManager.vala"
	_tmp0_ = _data8_->unsupported_file_dialog;
#line 200 "../src/Services/PlaybackManager.vala"
	gtk_window_destroy ((GtkWindow*) _tmp0_);
#line 622 "PlaybackManager.c"
}

static void
_____lambda11__gtk_dialog_response (GtkDialog* _sender,
                                    gint response_id,
                                    gpointer self)
{
#line 192 "../src/Services/PlaybackManager.vala"
	____lambda11_ (self, response_id);
#line 632 "PlaybackManager.c"
}

void
audience_playback_manager_play_file (AudiencePlaybackManager* self,
                                     const gchar* uri,
                                     gboolean from_beginning)
{
	GstElement* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GstElement* _tmp13_;
	GstElement* _tmp20_;
	GtkRecentManager* _tmp21_;
	GSettings* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 177 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (uri != NULL);
#line 178 "../src/Services/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:178: Opening %s", uri);
#line 180 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 180 "../src/Services/PlaybackManager.vala"
	gst_element_set_state (_tmp0_, GST_STATE_NULL);
#line 182 "../src/Services/PlaybackManager.vala"
	_tmp1_ = g_file_new_for_uri (uri);
#line 182 "../src/Services/PlaybackManager.vala"
	file = _tmp1_;
#line 662 "PlaybackManager.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp2_;
		const gchar* content_type = NULL;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 184 "../src/Services/PlaybackManager.vala"
		_tmp2_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE "," G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error0_);
#line 184 "../src/Services/PlaybackManager.vala"
		info = _tmp2_;
#line 184 "../src/Services/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 675 "PlaybackManager.c"
			goto __catch0_g_error;
		}
#line 185 "../src/Services/PlaybackManager.vala"
		_tmp3_ = g_file_info_get_content_type (info);
#line 185 "../src/Services/PlaybackManager.vala"
		content_type = _tmp3_;
#line 187 "../src/Services/PlaybackManager.vala"
		_tmp4_ = content_type;
#line 187 "../src/Services/PlaybackManager.vala"
		if (!g_content_type_is_a (_tmp4_, "video/*")) {
#line 686 "PlaybackManager.c"
			Block8Data* _data8_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			AudienceUnsupportedFileDialog* _tmp8_;
			AudienceUnsupportedFileDialog* _tmp9_;
			AudienceUnsupportedFileDialog* _tmp10_;
#line 187 "../src/Services/PlaybackManager.vala"
			_data8_ = g_slice_new0 (Block8Data);
#line 187 "../src/Services/PlaybackManager.vala"
			_data8_->_ref_count_ = 1;
#line 187 "../src/Services/PlaybackManager.vala"
			_data8_->self = g_object_ref (self);
#line 188 "../src/Services/PlaybackManager.vala"
			_tmp5_ = content_type;
#line 188 "../src/Services/PlaybackManager.vala"
			g_debug ("PlaybackManager.vala:188: Unrecognized file format: %s", _tmp5_);
#line 189 "../src/Services/PlaybackManager.vala"
			_tmp6_ = g_file_info_get_name (info);
#line 189 "../src/Services/PlaybackManager.vala"
			_tmp7_ = content_type;
#line 189 "../src/Services/PlaybackManager.vala"
			_tmp8_ = audience_unsupported_file_dialog_new (uri, _tmp6_, _tmp7_);
#line 189 "../src/Services/PlaybackManager.vala"
			g_object_ref_sink (_tmp8_);
#line 189 "../src/Services/PlaybackManager.vala"
			_data8_->unsupported_file_dialog = _tmp8_;
#line 190 "../src/Services/PlaybackManager.vala"
			_tmp9_ = _data8_->unsupported_file_dialog;
#line 190 "../src/Services/PlaybackManager.vala"
			gtk_window_present ((GtkWindow*) _tmp9_);
#line 192 "../src/Services/PlaybackManager.vala"
			_tmp10_ = _data8_->unsupported_file_dialog;
#line 192 "../src/Services/PlaybackManager.vala"
			g_signal_connect_data ((GtkDialog*) _tmp10_, "response", (GCallback) _____lambda11__gtk_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 187 "../src/Services/PlaybackManager.vala"
			block8_data_unref (_data8_);
#line 187 "../src/Services/PlaybackManager.vala"
			_data8_ = NULL;
#line 726 "PlaybackManager.c"
		}
#line 183 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (info);
#line 730 "PlaybackManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 183 "../src/Services/PlaybackManager.vala"
		e = _inner_error0_;
#line 183 "../src/Services/PlaybackManager.vala"
		_inner_error0_ = NULL;
#line 204 "../src/Services/PlaybackManager.vala"
		_tmp11_ = e;
#line 204 "../src/Services/PlaybackManager.vala"
		_tmp12_ = _tmp11_->message;
#line 204 "../src/Services/PlaybackManager.vala"
		g_debug ("PlaybackManager.vala:204: %s", _tmp12_);
#line 183 "../src/Services/PlaybackManager.vala"
		_g_error_free0 (e);
#line 750 "PlaybackManager.c"
	}
	__finally0:
#line 183 "../src/Services/PlaybackManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (file);
#line 183 "../src/Services/PlaybackManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../src/Services/PlaybackManager.vala"
		g_clear_error (&_inner_error0_);
#line 183 "../src/Services/PlaybackManager.vala"
		return;
#line 763 "PlaybackManager.c"
	}
#line 207 "../src/Services/PlaybackManager.vala"
	_tmp13_ = self->priv->playbin;
#line 207 "../src/Services/PlaybackManager.vala"
	g_object_set (_tmp13_, "uri", uri, NULL);
#line 210 "../src/Services/PlaybackManager.vala"
	if (from_beginning) {
#line 211 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_seek (self, (gint64) 0);
#line 773 "PlaybackManager.c"
	} else {
		GSettings* _tmp14_;
#line 213 "../src/Services/PlaybackManager.vala"
		_tmp14_ = audience_settings;
#line 213 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_seek (self, g_settings_get_int64 (_tmp14_, "last-stopped"));
#line 780 "PlaybackManager.c"
	}
#line 216 "../src/Services/PlaybackManager.vala"
	if (!from_beginning) {
#line 784 "PlaybackManager.c"
		GSettings* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 218 "../src/Services/PlaybackManager.vala"
		_tmp15_ = audience_settings;
#line 218 "../src/Services/PlaybackManager.vala"
		_tmp16_ = g_settings_get_string (_tmp15_, "current-external-subtitles-uri");
#line 218 "../src/Services/PlaybackManager.vala"
		_tmp17_ = _tmp16_;
#line 218 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_subtitle (self, _tmp17_);
#line 218 "../src/Services/PlaybackManager.vala"
		_g_free0 (_tmp17_);
#line 798 "PlaybackManager.c"
	} else {
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 220 "../src/Services/PlaybackManager.vala"
		_tmp18_ = audience_playback_manager_get_subtitle_for_uri (self, uri);
#line 220 "../src/Services/PlaybackManager.vala"
		_tmp19_ = _tmp18_;
#line 220 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_subtitle (self, _tmp19_);
#line 220 "../src/Services/PlaybackManager.vala"
		_g_free0 (_tmp19_);
#line 810 "PlaybackManager.c"
	}
#line 223 "../src/Services/PlaybackManager.vala"
	_tmp20_ = self->priv->playbin;
#line 223 "../src/Services/PlaybackManager.vala"
	gst_element_set_state (_tmp20_, GST_STATE_PLAYING);
#line 224 "../src/Services/PlaybackManager.vala"
	_tmp21_ = gtk_recent_manager_get_default ();
#line 224 "../src/Services/PlaybackManager.vala"
	gtk_recent_manager_add_item (_tmp21_, uri);
#line 226 "../src/Services/PlaybackManager.vala"
	_tmp22_ = audience_settings;
#line 226 "../src/Services/PlaybackManager.vala"
	g_settings_set_string (_tmp22_, "current-video", uri);
#line 177 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (file);
#line 826 "PlaybackManager.c"
}

void
audience_playback_manager_stop (AudiencePlaybackManager* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GSettings* _tmp4_;
	gboolean _tmp5_;
#line 229 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/Services/PlaybackManager.vala"
	_tmp0_ = audience_settings;
#line 230 "../src/Services/PlaybackManager.vala"
	g_settings_set_int64 (_tmp0_, "last-stopped", (gint64) 0);
#line 231 "../src/Services/PlaybackManager.vala"
	_tmp1_ = audience_settings;
#line 231 "../src/Services/PlaybackManager.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 231 "../src/Services/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 231 "../src/Services/PlaybackManager.vala"
	_tmp3__length1 = 0;
#line 231 "../src/Services/PlaybackManager.vala"
	g_settings_set_strv (_tmp1_, "last-played-videos", _tmp3_);
#line 231 "../src/Services/PlaybackManager.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 232 "../src/Services/PlaybackManager.vala"
	_tmp4_ = audience_settings;
#line 232 "../src/Services/PlaybackManager.vala"
	g_settings_set_string (_tmp4_, "current-video", "");
#line 237 "../src/Services/PlaybackManager.vala"
	_tmp5_ = self->priv->_playing;
#line 237 "../src/Services/PlaybackManager.vala"
	if (_tmp5_) {
#line 865 "PlaybackManager.c"
		GstElement* _tmp6_;
		gint64 _tmp7_;
#line 238 "../src/Services/PlaybackManager.vala"
		_tmp6_ = self->priv->playbin;
#line 238 "../src/Services/PlaybackManager.vala"
		gst_element_set_state (_tmp6_, GST_STATE_NULL);
#line 239 "../src/Services/PlaybackManager.vala"
		_tmp7_ = self->priv->_duration;
#line 239 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_seek (self, _tmp7_);
#line 240 "../src/Services/PlaybackManager.vala"
		g_signal_emit (self, audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_ENDED_SIGNAL], 0);
#line 878 "PlaybackManager.c"
	}
}

void
audience_playback_manager_clear_playlist (AudiencePlaybackManager* self,
                                          gboolean should_stop)
{
	GtkStringList* _tmp0_;
	GtkStringList* _tmp1_;
#line 244 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->_play_queue;
#line 245 "../src/Services/PlaybackManager.vala"
	_tmp1_ = self->priv->_play_queue;
#line 245 "../src/Services/PlaybackManager.vala"
	gtk_string_list_splice (_tmp0_, (guint) 0, g_list_model_get_n_items ((GListModel*) _tmp1_), NULL);
#line 247 "../src/Services/PlaybackManager.vala"
	if (should_stop) {
#line 248 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_stop (self);
#line 900 "PlaybackManager.c"
	}
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 259 "../src/Services/PlaybackManager.vala"
	if ((*length) == (*size)) {
#line 259 "../src/Services/PlaybackManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 259 "../src/Services/PlaybackManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 916 "PlaybackManager.c"
	}
#line 259 "../src/Services/PlaybackManager.vala"
	(*array)[(*length)++] = value;
#line 259 "../src/Services/PlaybackManager.vala"
	(*array)[*length] = NULL;
#line 922 "PlaybackManager.c"
}

void
audience_playback_manager_append_to_playlist (AudiencePlaybackManager* self,
                                              gchar** uris,
                                              gint uris_length1)
{
	gchar** uris_to_queue = NULL;
	gchar** _tmp0_;
	gint uris_to_queue_length1;
	gint _uris_to_queue_size_;
	GtkStringList* _tmp7_;
	GtkStringList* _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
#line 252 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/Services/PlaybackManager.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 253 "../src/Services/PlaybackManager.vala"
	uris_to_queue = _tmp0_;
#line 253 "../src/Services/PlaybackManager.vala"
	uris_to_queue_length1 = 0;
#line 253 "../src/Services/PlaybackManager.vala"
	_uris_to_queue_size_ = uris_to_queue_length1;
#line 948 "PlaybackManager.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 255 "../src/Services/PlaybackManager.vala"
		uri_collection = uris;
#line 255 "../src/Services/PlaybackManager.vala"
		uri_collection_length1 = uris_length1;
#line 255 "../src/Services/PlaybackManager.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 960 "PlaybackManager.c"
			gchar* _tmp1_;
			gchar* uri = NULL;
#line 255 "../src/Services/PlaybackManager.vala"
			_tmp1_ = g_strdup (uri_collection[uri_it]);
#line 255 "../src/Services/PlaybackManager.vala"
			uri = _tmp1_;
#line 967 "PlaybackManager.c"
			{
				const gchar* _tmp2_;
#line 256 "../src/Services/PlaybackManager.vala"
				_tmp2_ = uri;
#line 256 "../src/Services/PlaybackManager.vala"
				if (audience_playback_manager_is_subtitle (self, _tmp2_)) {
#line 974 "PlaybackManager.c"
					const gchar* _tmp3_;
#line 257 "../src/Services/PlaybackManager.vala"
					_tmp3_ = uri;
#line 257 "../src/Services/PlaybackManager.vala"
					audience_playback_manager_set_subtitle_uri (self, _tmp3_);
#line 980 "PlaybackManager.c"
				} else {
					const gchar* _tmp4_;
#line 258 "../src/Services/PlaybackManager.vala"
					_tmp4_ = uri;
#line 258 "../src/Services/PlaybackManager.vala"
					if (audience_playback_manager_get_queue_position (self, _tmp4_) == GTK_INVALID_LIST_POSITION) {
#line 987 "PlaybackManager.c"
						const gchar* _tmp5_;
						gchar* _tmp6_;
#line 259 "../src/Services/PlaybackManager.vala"
						_tmp5_ = uri;
#line 259 "../src/Services/PlaybackManager.vala"
						_tmp6_ = g_strdup (_tmp5_);
#line 259 "../src/Services/PlaybackManager.vala"
						_vala_array_add9 (&uris_to_queue, &uris_to_queue_length1, &_uris_to_queue_size_, _tmp6_);
#line 996 "PlaybackManager.c"
					}
				}
#line 255 "../src/Services/PlaybackManager.vala"
				_g_free0 (uri);
#line 1001 "PlaybackManager.c"
			}
		}
	}
#line 263 "../src/Services/PlaybackManager.vala"
	_tmp7_ = self->priv->_play_queue;
#line 263 "../src/Services/PlaybackManager.vala"
	_tmp8_ = self->priv->_play_queue;
#line 263 "../src/Services/PlaybackManager.vala"
	_tmp9_ = uris_to_queue;
#line 263 "../src/Services/PlaybackManager.vala"
	_tmp9__length1 = uris_to_queue_length1;
#line 263 "../src/Services/PlaybackManager.vala"
	gtk_string_list_splice (_tmp7_, g_list_model_get_n_items ((GListModel*) _tmp8_), (guint) 0, _tmp9_);
#line 252 "../src/Services/PlaybackManager.vala"
	uris_to_queue = (_vala_array_free (uris_to_queue, uris_to_queue_length1, (GDestroyNotify) g_free), NULL);
#line 1017 "PlaybackManager.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 274 "../src/Services/PlaybackManager.vala"
	if ((*length) == (*size)) {
#line 274 "../src/Services/PlaybackManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 274 "../src/Services/PlaybackManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1032 "PlaybackManager.c"
	}
#line 274 "../src/Services/PlaybackManager.vala"
	(*array)[(*length)++] = value;
#line 274 "../src/Services/PlaybackManager.vala"
	(*array)[*length] = NULL;
#line 1038 "PlaybackManager.c"
}

void
audience_playback_manager_save_playlist (AudiencePlaybackManager* self)
{
	GSettings* privacy_settings = NULL;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
	gchar** videos = NULL;
	gchar** _tmp4_;
	gint videos_length1;
	gint _videos_size_;
	GSettings* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
#line 266 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/Services/PlaybackManager.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.privacy");
#line 267 "../src/Services/PlaybackManager.vala"
	privacy_settings = _tmp0_;
#line 268 "../src/Services/PlaybackManager.vala"
	_tmp2_ = privacy_settings;
#line 268 "../src/Services/PlaybackManager.vala"
	if (!g_settings_get_boolean (_tmp2_, "remember-recent-files")) {
#line 268 "../src/Services/PlaybackManager.vala"
		_tmp1_ = TRUE;
#line 1067 "PlaybackManager.c"
	} else {
		GSettings* _tmp3_;
#line 268 "../src/Services/PlaybackManager.vala"
		_tmp3_ = privacy_settings;
#line 268 "../src/Services/PlaybackManager.vala"
		_tmp1_ = !g_settings_get_boolean (_tmp3_, "remember-app-usage");
#line 1074 "PlaybackManager.c"
	}
#line 268 "../src/Services/PlaybackManager.vala"
	if (_tmp1_) {
#line 269 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (privacy_settings);
#line 269 "../src/Services/PlaybackManager.vala"
		return;
#line 1082 "PlaybackManager.c"
	}
#line 272 "../src/Services/PlaybackManager.vala"
	_tmp4_ = g_new0 (gchar*, 0 + 1);
#line 272 "../src/Services/PlaybackManager.vala"
	videos = _tmp4_;
#line 272 "../src/Services/PlaybackManager.vala"
	videos_length1 = 0;
#line 272 "../src/Services/PlaybackManager.vala"
	_videos_size_ = videos_length1;
#line 1092 "PlaybackManager.c"
	{
		gint i = 0;
#line 273 "../src/Services/PlaybackManager.vala"
		i = 0;
#line 1097 "PlaybackManager.c"
		{
			gboolean _tmp5_ = FALSE;
#line 273 "../src/Services/PlaybackManager.vala"
			_tmp5_ = TRUE;
#line 273 "../src/Services/PlaybackManager.vala"
			while (TRUE) {
#line 1104 "PlaybackManager.c"
				GtkStringList* _tmp7_;
				GtkStringList* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 273 "../src/Services/PlaybackManager.vala"
				if (!_tmp5_) {
#line 1111 "PlaybackManager.c"
					gint _tmp6_;
#line 273 "../src/Services/PlaybackManager.vala"
					_tmp6_ = i;
#line 273 "../src/Services/PlaybackManager.vala"
					i = _tmp6_ + 1;
#line 1117 "PlaybackManager.c"
				}
#line 273 "../src/Services/PlaybackManager.vala"
				_tmp5_ = FALSE;
#line 273 "../src/Services/PlaybackManager.vala"
				_tmp7_ = self->priv->_play_queue;
#line 273 "../src/Services/PlaybackManager.vala"
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp7_))) {
#line 273 "../src/Services/PlaybackManager.vala"
					break;
#line 1127 "PlaybackManager.c"
				}
#line 274 "../src/Services/PlaybackManager.vala"
				_tmp8_ = self->priv->_play_queue;
#line 274 "../src/Services/PlaybackManager.vala"
				_tmp9_ = gtk_string_list_get_string (_tmp8_, (guint) i);
#line 274 "../src/Services/PlaybackManager.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 274 "../src/Services/PlaybackManager.vala"
				_vala_array_add10 (&videos, &videos_length1, &_videos_size_, _tmp10_);
#line 1137 "PlaybackManager.c"
			}
		}
	}
#line 277 "../src/Services/PlaybackManager.vala"
	_tmp11_ = audience_settings;
#line 277 "../src/Services/PlaybackManager.vala"
	_tmp12_ = videos;
#line 277 "../src/Services/PlaybackManager.vala"
	_tmp12__length1 = videos_length1;
#line 277 "../src/Services/PlaybackManager.vala"
	g_settings_set_strv (_tmp11_, "last-played-videos", _tmp12_);
#line 266 "../src/Services/PlaybackManager.vala"
	videos = (_vala_array_free (videos, videos_length1, (GDestroyNotify) g_free), NULL);
#line 266 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (privacy_settings);
#line 1153 "PlaybackManager.c"
}

gboolean
audience_playback_manager_next (AudiencePlaybackManager* self)
{
	guint position = 0U;
	GstElement* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkStringList* _tmp3_;
	gboolean result;
#line 280 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 281 "../src/Services/PlaybackManager.vala"
	g_object_get (_tmp0_, "current-uri", &_tmp1_, NULL);
#line 281 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 281 "../src/Services/PlaybackManager.vala"
	position = audience_playback_manager_get_queue_position (self, _tmp2_);
#line 283 "../src/Services/PlaybackManager.vala"
	_tmp3_ = self->priv->_play_queue;
#line 283 "../src/Services/PlaybackManager.vala"
	if (position < (g_list_model_get_n_items ((GListModel*) _tmp3_) - 1)) {
#line 1179 "PlaybackManager.c"
		GtkStringList* _tmp4_;
		const gchar* _tmp5_;
#line 284 "../src/Services/PlaybackManager.vala"
		_tmp4_ = self->priv->_play_queue;
#line 284 "../src/Services/PlaybackManager.vala"
		_tmp5_ = gtk_string_list_get_string (_tmp4_, position + 1);
#line 284 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_play_file (self, _tmp5_, TRUE);
#line 285 "../src/Services/PlaybackManager.vala"
		result = TRUE;
#line 285 "../src/Services/PlaybackManager.vala"
		return result;
#line 1192 "PlaybackManager.c"
	}
#line 288 "../src/Services/PlaybackManager.vala"
	result = FALSE;
#line 288 "../src/Services/PlaybackManager.vala"
	return result;
#line 1198 "PlaybackManager.c"
}

void
audience_playback_manager_previous (AudiencePlaybackManager* self)
{
	guint position = 0U;
	GstElement* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 291 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 292 "../src/Services/PlaybackManager.vala"
	g_object_get (_tmp0_, "current-uri", &_tmp1_, NULL);
#line 292 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 292 "../src/Services/PlaybackManager.vala"
	position = audience_playback_manager_get_queue_position (self, _tmp2_);
#line 294 "../src/Services/PlaybackManager.vala"
	if (position == ((guint) 0)) {
#line 295 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_seek (self, (gint64) 0);
#line 1222 "PlaybackManager.c"
	} else {
#line 296 "../src/Services/PlaybackManager.vala"
		if (position != GTK_INVALID_LIST_POSITION) {
#line 1226 "PlaybackManager.c"
			GtkStringList* _tmp3_;
			const gchar* _tmp4_;
#line 297 "../src/Services/PlaybackManager.vala"
			_tmp3_ = self->priv->_play_queue;
#line 297 "../src/Services/PlaybackManager.vala"
			_tmp4_ = gtk_string_list_get_string (_tmp3_, position - 1);
#line 297 "../src/Services/PlaybackManager.vala"
			audience_playback_manager_play_file (self, _tmp4_, TRUE);
#line 1235 "PlaybackManager.c"
		}
	}
}

void
audience_playback_manager_seek (AudiencePlaybackManager* self,
                                gint64 position)
{
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	GstElement* _tmp5_;
#line 301 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 303 "../src/Services/PlaybackManager.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 0);
#line 303 "../src/Services/PlaybackManager.vala"
	state = _tmp1_;
#line 303 "../src/Services/PlaybackManager.vala"
	pending = _tmp2_;
#line 305 "../src/Services/PlaybackManager.vala"
	if (self->priv->is_seeking) {
#line 305 "../src/Services/PlaybackManager.vala"
		_tmp3_ = TRUE;
#line 1265 "PlaybackManager.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 305 "../src/Services/PlaybackManager.vala"
		if (state != GST_STATE_PAUSED) {
#line 305 "../src/Services/PlaybackManager.vala"
			_tmp4_ = state != GST_STATE_PLAYING;
#line 1272 "PlaybackManager.c"
		} else {
#line 305 "../src/Services/PlaybackManager.vala"
			_tmp4_ = FALSE;
#line 1276 "PlaybackManager.c"
		}
#line 305 "../src/Services/PlaybackManager.vala"
		_tmp3_ = _tmp4_;
#line 1280 "PlaybackManager.c"
	}
#line 305 "../src/Services/PlaybackManager.vala"
	if (_tmp3_) {
#line 306 "../src/Services/PlaybackManager.vala"
		self->priv->queued_seek = position;
#line 307 "../src/Services/PlaybackManager.vala"
		return;
#line 1288 "PlaybackManager.c"
	}
#line 310 "../src/Services/PlaybackManager.vala"
	_tmp5_ = self->priv->playbin;
#line 310 "../src/Services/PlaybackManager.vala"
	if (gst_element_seek_simple (_tmp5_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_ACCURATE, position)) {
#line 311 "../src/Services/PlaybackManager.vala"
		self->priv->is_seeking = TRUE;
#line 1296 "PlaybackManager.c"
	} else {
#line 313 "../src/Services/PlaybackManager.vala"
		g_warning ("PlaybackManager.vala:313: Failed to seek.");
#line 1300 "PlaybackManager.c"
	}
#line 316 "../src/Services/PlaybackManager.vala"
	self->priv->queued_seek = (gint64) -1;
#line 1304 "PlaybackManager.c"
}

static void
audience_playback_manager_update_position (AudiencePlaybackManager* self)
{
	gint64 _position = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gboolean _tmp2_;
#line 319 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 321 "../src/Services/PlaybackManager.vala"
	_tmp2_ = gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 321 "../src/Services/PlaybackManager.vala"
	_position = _tmp1_;
#line 321 "../src/Services/PlaybackManager.vala"
	if (_tmp2_) {
#line 322 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_position (self, _position);
#line 1326 "PlaybackManager.c"
	} else {
#line 324 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_position (self, (gint64) 0);
#line 1330 "PlaybackManager.c"
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 1345 "PlaybackManager.c"
}

static gboolean
audience_playback_manager_is_subtitle (AudiencePlaybackManager* self,
                                       const gchar* uri)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 328 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 328 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 329 "../src/Services/PlaybackManager.vala"
	_tmp1_ = strlen (uri);
#line 329 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 329 "../src/Services/PlaybackManager.vala"
	if (_tmp2_ < 4) {
#line 329 "../src/Services/PlaybackManager.vala"
		_tmp0_ = TRUE;
#line 1368 "PlaybackManager.c"
	} else {
		gint _tmp3_;
		gint _tmp4_;
#line 329 "../src/Services/PlaybackManager.vala"
		_tmp3_ = strlen (uri);
#line 329 "../src/Services/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 329 "../src/Services/PlaybackManager.vala"
		_tmp0_ = string_get_char (uri, (glong) (_tmp4_ - 4)) != ((gunichar) '.');
#line 1378 "PlaybackManager.c"
	}
#line 329 "../src/Services/PlaybackManager.vala"
	if (_tmp0_) {
#line 330 "../src/Services/PlaybackManager.vala"
		result = FALSE;
#line 330 "../src/Services/PlaybackManager.vala"
		return result;
#line 1386 "PlaybackManager.c"
	}
	{
		const gchar** ext_collection = NULL;
		gint ext_collection_length1 = 0;
		gint _ext_collection_size_ = 0;
		gint ext_it = 0;
#line 333 "../src/Services/PlaybackManager.vala"
		ext_collection = AUDIENCE_SUBTITLE_EXTENSIONS;
#line 333 "../src/Services/PlaybackManager.vala"
		ext_collection_length1 = G_N_ELEMENTS (AUDIENCE_SUBTITLE_EXTENSIONS);
#line 333 "../src/Services/PlaybackManager.vala"
		for (ext_it = 0; ext_it < ext_collection_length1; ext_it = ext_it + 1) {
#line 1399 "PlaybackManager.c"
			const gchar* ext = NULL;
#line 333 "../src/Services/PlaybackManager.vala"
			ext = ext_collection[ext_it];
#line 1403 "PlaybackManager.c"
			{
				gchar* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
				gboolean _tmp8_;
#line 334 "../src/Services/PlaybackManager.vala"
				_tmp5_ = g_utf8_strdown (uri, (gssize) -1);
#line 334 "../src/Services/PlaybackManager.vala"
				_tmp6_ = _tmp5_;
#line 334 "../src/Services/PlaybackManager.vala"
				_tmp7_ = ext;
#line 334 "../src/Services/PlaybackManager.vala"
				_tmp8_ = g_str_has_suffix (_tmp6_, _tmp7_);
#line 334 "../src/Services/PlaybackManager.vala"
				_g_free0 (_tmp6_);
#line 334 "../src/Services/PlaybackManager.vala"
				if (_tmp8_) {
#line 335 "../src/Services/PlaybackManager.vala"
					result = TRUE;
#line 335 "../src/Services/PlaybackManager.vala"
					return result;
#line 1425 "PlaybackManager.c"
				}
			}
		}
	}
#line 339 "../src/Services/PlaybackManager.vala"
	result = FALSE;
#line 339 "../src/Services/PlaybackManager.vala"
	return result;
#line 1434 "PlaybackManager.c"
}

GList*
audience_playback_manager_get_audio_tracks (AudiencePlaybackManager* self)
{
	GList* list = NULL;
	GList* result;
#line 342 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 343 "../src/Services/PlaybackManager.vala"
	list = NULL;
#line 1446 "PlaybackManager.c"
	{
		gint i = 0;
#line 345 "../src/Services/PlaybackManager.vala"
		i = 0;
#line 1451 "PlaybackManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 345 "../src/Services/PlaybackManager.vala"
			_tmp0_ = TRUE;
#line 345 "../src/Services/PlaybackManager.vala"
			while (TRUE) {
#line 1458 "PlaybackManager.c"
				GstElement* _tmp2_;
				GstElement* _tmp3_;
				GstElement* _tmp4_;
				GstTagList* tag_list = NULL;
				GstElement* _tmp5_;
				GstTagList* _tmp6_ = NULL;
				gchar* lang_code = NULL;
				GstTagList* _tmp7_;
				gchar* _tmp8_ = NULL;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 345 "../src/Services/PlaybackManager.vala"
				if (!_tmp0_) {
#line 1472 "PlaybackManager.c"
					gint _tmp1_;
#line 345 "../src/Services/PlaybackManager.vala"
					_tmp1_ = i;
#line 345 "../src/Services/PlaybackManager.vala"
					i = _tmp1_ + 1;
#line 1478 "PlaybackManager.c"
				}
#line 345 "../src/Services/PlaybackManager.vala"
				_tmp0_ = FALSE;
#line 345 "../src/Services/PlaybackManager.vala"
				_tmp2_ = self->priv->playbin;
#line 345 "../src/Services/PlaybackManager.vala"
				g_object_get (_tmp2_, "n-audio", &_tmp3_, NULL);
#line 345 "../src/Services/PlaybackManager.vala"
				_tmp4_ = _tmp3_;
#line 345 "../src/Services/PlaybackManager.vala"
				if (!(i < ((gint) _tmp4_))) {
#line 345 "../src/Services/PlaybackManager.vala"
					break;
#line 1492 "PlaybackManager.c"
				}
#line 347 "../src/Services/PlaybackManager.vala"
				_tmp5_ = self->priv->playbin;
#line 347 "../src/Services/PlaybackManager.vala"
				g_signal_emit_by_name (_tmp5_, "get-audio-tags", i, &_tmp6_, NULL);
#line 347 "../src/Services/PlaybackManager.vala"
				_gst_tag_list_unref0 (tag_list);
#line 347 "../src/Services/PlaybackManager.vala"
				tag_list = _tmp6_;
#line 350 "../src/Services/PlaybackManager.vala"
				_tmp7_ = tag_list;
#line 350 "../src/Services/PlaybackManager.vala"
				gst_tag_list_get_string (_tmp7_, "language-code", &_tmp8_);
#line 350 "../src/Services/PlaybackManager.vala"
				_g_free0 (lang_code);
#line 350 "../src/Services/PlaybackManager.vala"
				lang_code = _tmp8_;
#line 352 "../src/Services/PlaybackManager.vala"
				_tmp9_ = lang_code;
#line 352 "../src/Services/PlaybackManager.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 352 "../src/Services/PlaybackManager.vala"
				list = g_list_append (list, _tmp10_);
#line 345 "../src/Services/PlaybackManager.vala"
				_g_free0 (lang_code);
#line 345 "../src/Services/PlaybackManager.vala"
				_gst_tag_list_unref0 (tag_list);
#line 1520 "PlaybackManager.c"
			}
		}
	}
#line 355 "../src/Services/PlaybackManager.vala"
	result = list;
#line 355 "../src/Services/PlaybackManager.vala"
	return result;
#line 1528 "PlaybackManager.c"
}

GList*
audience_playback_manager_get_subtitle_tracks (AudiencePlaybackManager* self)
{
	GList* list = NULL;
	GList* result;
#line 358 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 359 "../src/Services/PlaybackManager.vala"
	list = NULL;
#line 1540 "PlaybackManager.c"
	{
		gint i = 0;
#line 361 "../src/Services/PlaybackManager.vala"
		i = 0;
#line 1545 "PlaybackManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 361 "../src/Services/PlaybackManager.vala"
			_tmp0_ = TRUE;
#line 361 "../src/Services/PlaybackManager.vala"
			while (TRUE) {
#line 1552 "PlaybackManager.c"
				GstElement* _tmp2_;
				GstElement* _tmp3_;
				GstElement* _tmp4_;
				GstTagList* tag_list = NULL;
				GstElement* _tmp5_;
				GstTagList* _tmp6_ = NULL;
				gchar* lang_code = NULL;
				GstTagList* _tmp7_;
				gchar* _tmp8_ = NULL;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 361 "../src/Services/PlaybackManager.vala"
				if (!_tmp0_) {
#line 1566 "PlaybackManager.c"
					gint _tmp1_;
#line 361 "../src/Services/PlaybackManager.vala"
					_tmp1_ = i;
#line 361 "../src/Services/PlaybackManager.vala"
					i = _tmp1_ + 1;
#line 1572 "PlaybackManager.c"
				}
#line 361 "../src/Services/PlaybackManager.vala"
				_tmp0_ = FALSE;
#line 361 "../src/Services/PlaybackManager.vala"
				_tmp2_ = self->priv->playbin;
#line 361 "../src/Services/PlaybackManager.vala"
				g_object_get (_tmp2_, "n-text", &_tmp3_, NULL);
#line 361 "../src/Services/PlaybackManager.vala"
				_tmp4_ = _tmp3_;
#line 361 "../src/Services/PlaybackManager.vala"
				if (!(i < ((gint) _tmp4_))) {
#line 361 "../src/Services/PlaybackManager.vala"
					break;
#line 1586 "PlaybackManager.c"
				}
#line 363 "../src/Services/PlaybackManager.vala"
				_tmp5_ = self->priv->playbin;
#line 363 "../src/Services/PlaybackManager.vala"
				g_signal_emit_by_name (_tmp5_, "get-text-tags", i, &_tmp6_, NULL);
#line 363 "../src/Services/PlaybackManager.vala"
				_gst_tag_list_unref0 (tag_list);
#line 363 "../src/Services/PlaybackManager.vala"
				tag_list = _tmp6_;
#line 366 "../src/Services/PlaybackManager.vala"
				_tmp7_ = tag_list;
#line 366 "../src/Services/PlaybackManager.vala"
				gst_tag_list_get_string (_tmp7_, "language-code", &_tmp8_);
#line 366 "../src/Services/PlaybackManager.vala"
				_g_free0 (lang_code);
#line 366 "../src/Services/PlaybackManager.vala"
				lang_code = _tmp8_;
#line 368 "../src/Services/PlaybackManager.vala"
				_tmp9_ = lang_code;
#line 368 "../src/Services/PlaybackManager.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 368 "../src/Services/PlaybackManager.vala"
				list = g_list_append (list, _tmp10_);
#line 361 "../src/Services/PlaybackManager.vala"
				_g_free0 (lang_code);
#line 361 "../src/Services/PlaybackManager.vala"
				_gst_tag_list_unref0 (tag_list);
#line 1614 "PlaybackManager.c"
			}
		}
	}
#line 371 "../src/Services/PlaybackManager.vala"
	result = list;
#line 371 "../src/Services/PlaybackManager.vala"
	return result;
#line 1622 "PlaybackManager.c"
}

gchar*
audience_playback_manager_get_uri (AudiencePlaybackManager* self)
{
	GstElement* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 374 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 375 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 375 "../src/Services/PlaybackManager.vala"
	g_object_get (_tmp0_, "current-uri", &_tmp1_, NULL);
#line 375 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 375 "../src/Services/PlaybackManager.vala"
	result = _tmp2_;
#line 375 "../src/Services/PlaybackManager.vala"
	return result;
#line 1644 "PlaybackManager.c"
}

gint
audience_playback_manager_get_audio_track (AudiencePlaybackManager* self)
{
	GstElement* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 378 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 379 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 379 "../src/Services/PlaybackManager.vala"
	g_object_get (_tmp0_, "current-audio", &_tmp1_, NULL);
#line 379 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 379 "../src/Services/PlaybackManager.vala"
	result = _tmp2_;
#line 379 "../src/Services/PlaybackManager.vala"
	return result;
#line 1666 "PlaybackManager.c"
}

void
audience_playback_manager_set_audio_track (AudiencePlaybackManager* self,
                                           gint track)
{
	GstElement* _tmp0_;
#line 382 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 383 "../src/Services/PlaybackManager.vala"
	g_object_set (_tmp0_, "current-audio", track, NULL);
#line 1680 "PlaybackManager.c"
}

gint
audience_playback_manager_get_subtitle_track (AudiencePlaybackManager* self)
{
	GstElement* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 386 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 387 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 387 "../src/Services/PlaybackManager.vala"
	g_object_get (_tmp0_, "current-text", &_tmp1_, NULL);
#line 387 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 387 "../src/Services/PlaybackManager.vala"
	result = _tmp2_;
#line 387 "../src/Services/PlaybackManager.vala"
	return result;
#line 1702 "PlaybackManager.c"
}

void
audience_playback_manager_set_subtitle_track (AudiencePlaybackManager* self,
                                              gint track)
{
	GstElement* _tmp0_;
#line 390 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 391 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 391 "../src/Services/PlaybackManager.vala"
	g_object_set (_tmp0_, "current-text", track, NULL);
#line 1716 "PlaybackManager.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 397 "../src/Services/PlaybackManager.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 397 "../src/Services/PlaybackManager.vala"
	return _data9_;
#line 1726 "PlaybackManager.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 397 "../src/Services/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 1736 "PlaybackManager.c"
		AudiencePlaybackManager* self;
#line 397 "../src/Services/PlaybackManager.vala"
		self = _data9_->self;
#line 397 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 397 "../src/Services/PlaybackManager.vala"
		g_slice_free (Block9Data, _data9_);
#line 1744 "PlaybackManager.c"
	}
}

static void
___lambda12_ (Block9Data* _data9_)
{
	AudiencePlaybackManager* self;
	gboolean _tmp0_;
#line 404 "../src/Services/PlaybackManager.vala"
	self = _data9_->self;
#line 405 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->_playing;
#line 405 "../src/Services/PlaybackManager.vala"
	if (!_tmp0_) {
#line 406 "../src/Services/PlaybackManager.vala"
		return;
#line 1761 "PlaybackManager.c"
	}
#line 409 "../src/Services/PlaybackManager.vala"
	g_signal_handler_disconnect ((GObject*) self, _data9_->ready_handler_id);
#line 411 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_seek (self, _data9_->temp_position);
#line 414 "../src/Services/PlaybackManager.vala"
	if (!_data9_->temp_playing) {
#line 1769 "PlaybackManager.c"
		GstElement* _tmp1_;
#line 415 "../src/Services/PlaybackManager.vala"
		_tmp1_ = self->priv->playbin;
#line 415 "../src/Services/PlaybackManager.vala"
		gst_element_set_state (_tmp1_, GST_STATE_PAUSED);
#line 1775 "PlaybackManager.c"
	}
}

static void
____lambda12__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 404 "../src/Services/PlaybackManager.vala"
	___lambda12_ (self);
#line 1786 "PlaybackManager.c"
}

void
audience_playback_manager_set_subtitle (AudiencePlaybackManager* self,
                                        const gchar* uri)
{
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	GstElement* _tmp7_;
	GstElement* _tmp8_;
	GstElement* _tmp9_;
	GSettings* _tmp10_;
#line 394 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 394 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (uri != NULL);
#line 396 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 396 "../src/Services/PlaybackManager.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 0);
#line 396 "../src/Services/PlaybackManager.vala"
	state = _tmp1_;
#line 396 "../src/Services/PlaybackManager.vala"
	pending = _tmp2_;
#line 397 "../src/Services/PlaybackManager.vala"
	if (state == GST_STATE_PAUSED) {
#line 397 "../src/Services/PlaybackManager.vala"
		_tmp3_ = TRUE;
#line 1819 "PlaybackManager.c"
	} else {
#line 397 "../src/Services/PlaybackManager.vala"
		_tmp3_ = state == GST_STATE_PLAYING;
#line 1823 "PlaybackManager.c"
	}
#line 397 "../src/Services/PlaybackManager.vala"
	if (_tmp3_) {
#line 1827 "PlaybackManager.c"
		Block9Data* _data9_;
		gboolean _tmp4_;
		gint64 _tmp5_;
		gulong _tmp6_;
#line 397 "../src/Services/PlaybackManager.vala"
		_data9_ = g_slice_new0 (Block9Data);
#line 397 "../src/Services/PlaybackManager.vala"
		_data9_->_ref_count_ = 1;
#line 397 "../src/Services/PlaybackManager.vala"
		_data9_->self = g_object_ref (self);
#line 398 "../src/Services/PlaybackManager.vala"
		_tmp4_ = self->priv->_playing;
#line 398 "../src/Services/PlaybackManager.vala"
		_data9_->temp_playing = _tmp4_;
#line 399 "../src/Services/PlaybackManager.vala"
		_tmp5_ = self->priv->_position;
#line 399 "../src/Services/PlaybackManager.vala"
		_data9_->temp_position = _tmp5_;
#line 403 "../src/Services/PlaybackManager.vala"
		_data9_->ready_handler_id = (gulong) 0;
#line 404 "../src/Services/PlaybackManager.vala"
		_tmp6_ = g_signal_connect_data ((GObject*) self, "notify::playing", (GCallback) ____lambda12__g_object_notify, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 404 "../src/Services/PlaybackManager.vala"
		_data9_->ready_handler_id = _tmp6_;
#line 397 "../src/Services/PlaybackManager.vala"
		block9_data_unref (_data9_);
#line 397 "../src/Services/PlaybackManager.vala"
		_data9_ = NULL;
#line 1856 "PlaybackManager.c"
	}
#line 420 "../src/Services/PlaybackManager.vala"
	_tmp7_ = self->priv->playbin;
#line 420 "../src/Services/PlaybackManager.vala"
	gst_element_set_state (_tmp7_, GST_STATE_NULL);
#line 421 "../src/Services/PlaybackManager.vala"
	_tmp8_ = self->priv->playbin;
#line 421 "../src/Services/PlaybackManager.vala"
	g_object_set (_tmp8_, "suburi", uri, NULL);
#line 422 "../src/Services/PlaybackManager.vala"
	_tmp9_ = self->priv->playbin;
#line 422 "../src/Services/PlaybackManager.vala"
	gst_element_set_state (_tmp9_, GST_STATE_PLAYING);
#line 424 "../src/Services/PlaybackManager.vala"
	_tmp10_ = audience_settings;
#line 424 "../src/Services/PlaybackManager.vala"
	g_settings_set_string (_tmp10_, "current-external-subtitles-uri", uri);
#line 1874 "PlaybackManager.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1195 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1195 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1197 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1197 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1898 "PlaybackManager.c"
		gchar* _tmp2_;
#line 1198 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1198 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1198 "glib-2.0.vapi"
		return result;
#line 1906 "PlaybackManager.c"
	} else {
#line 1200 "glib-2.0.vapi"
		result = -1;
#line 1200 "glib-2.0.vapi"
		return result;
#line 1912 "PlaybackManager.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1940 "PlaybackManager.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1946 "PlaybackManager.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1952 "PlaybackManager.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1956 "PlaybackManager.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1964 "PlaybackManager.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1968 "PlaybackManager.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1980 "PlaybackManager.c"
}

static gchar*
audience_playback_manager_get_subtitle_for_uri (AudiencePlaybackManager* self,
                                                const gchar* uri)
{
	gchar* without_ext = NULL;
	gint last_dot = 0;
	gint last_slash = 0;
	gchar* _tmp13_;
	gchar* result;
#line 427 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 427 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 431 "../src/Services/PlaybackManager.vala"
	last_dot = string_last_index_of (uri, ".", 0);
#line 432 "../src/Services/PlaybackManager.vala"
	last_slash = string_last_index_of (uri, "/", 0);
#line 434 "../src/Services/PlaybackManager.vala"
	if (last_dot < last_slash) {
#line 2002 "PlaybackManager.c"
		gchar* _tmp0_;
#line 435 "../src/Services/PlaybackManager.vala"
		_tmp0_ = g_strdup (uri);
#line 435 "../src/Services/PlaybackManager.vala"
		_g_free0 (without_ext);
#line 435 "../src/Services/PlaybackManager.vala"
		without_ext = _tmp0_;
#line 2010 "PlaybackManager.c"
	} else {
		gchar* _tmp1_;
#line 437 "../src/Services/PlaybackManager.vala"
		_tmp1_ = string_slice (uri, (glong) 0, (glong) last_dot);
#line 437 "../src/Services/PlaybackManager.vala"
		_g_free0 (without_ext);
#line 437 "../src/Services/PlaybackManager.vala"
		without_ext = _tmp1_;
#line 2019 "PlaybackManager.c"
	}
	{
		const gchar** ext_collection = NULL;
		gint ext_collection_length1 = 0;
		gint _ext_collection_size_ = 0;
		gint ext_it = 0;
#line 440 "../src/Services/PlaybackManager.vala"
		ext_collection = AUDIENCE_SUBTITLE_EXTENSIONS;
#line 440 "../src/Services/PlaybackManager.vala"
		ext_collection_length1 = G_N_ELEMENTS (AUDIENCE_SUBTITLE_EXTENSIONS);
#line 440 "../src/Services/PlaybackManager.vala"
		for (ext_it = 0; ext_it < ext_collection_length1; ext_it = ext_it + 1) {
#line 2032 "PlaybackManager.c"
			gchar* _tmp2_;
			gchar* ext = NULL;
#line 440 "../src/Services/PlaybackManager.vala"
			_tmp2_ = g_strdup (ext_collection[ext_it]);
#line 440 "../src/Services/PlaybackManager.vala"
			ext = _tmp2_;
#line 2039 "PlaybackManager.c"
			{
				gchar* sub_uri = NULL;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				const gchar* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				gboolean _tmp12_;
#line 441 "../src/Services/PlaybackManager.vala"
				_tmp3_ = without_ext;
#line 441 "../src/Services/PlaybackManager.vala"
				_tmp4_ = g_strconcat (_tmp3_, ".", NULL);
#line 441 "../src/Services/PlaybackManager.vala"
				_tmp5_ = _tmp4_;
#line 441 "../src/Services/PlaybackManager.vala"
				_tmp6_ = ext;
#line 441 "../src/Services/PlaybackManager.vala"
				_tmp7_ = g_strconcat (_tmp5_, _tmp6_, NULL);
#line 441 "../src/Services/PlaybackManager.vala"
				_tmp8_ = _tmp7_;
#line 441 "../src/Services/PlaybackManager.vala"
				_g_free0 (_tmp5_);
#line 441 "../src/Services/PlaybackManager.vala"
				sub_uri = _tmp8_;
#line 442 "../src/Services/PlaybackManager.vala"
				_tmp9_ = sub_uri;
#line 442 "../src/Services/PlaybackManager.vala"
				_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 442 "../src/Services/PlaybackManager.vala"
				_tmp11_ = _tmp10_;
#line 442 "../src/Services/PlaybackManager.vala"
				_tmp12_ = g_file_query_exists (_tmp11_, NULL);
#line 442 "../src/Services/PlaybackManager.vala"
				_g_object_unref0 (_tmp11_);
#line 442 "../src/Services/PlaybackManager.vala"
				if (_tmp12_) {
#line 443 "../src/Services/PlaybackManager.vala"
					result = sub_uri;
#line 443 "../src/Services/PlaybackManager.vala"
					_g_free0 (ext);
#line 443 "../src/Services/PlaybackManager.vala"
					_g_free0 (without_ext);
#line 443 "../src/Services/PlaybackManager.vala"
					return result;
#line 2088 "PlaybackManager.c"
				}
#line 440 "../src/Services/PlaybackManager.vala"
				_g_free0 (sub_uri);
#line 440 "../src/Services/PlaybackManager.vala"
				_g_free0 (ext);
#line 2094 "PlaybackManager.c"
			}
		}
	}
#line 447 "../src/Services/PlaybackManager.vala"
	_tmp13_ = g_strdup ("");
#line 447 "../src/Services/PlaybackManager.vala"
	result = _tmp13_;
#line 447 "../src/Services/PlaybackManager.vala"
	_g_free0 (without_ext);
#line 447 "../src/Services/PlaybackManager.vala"
	return result;
#line 2106 "PlaybackManager.c"
}

static guint
audience_playback_manager_get_queue_position (AudiencePlaybackManager* self,
                                              const gchar* uri)
{
	guint position = 0U;
	guint result;
#line 450 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 450 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (uri != NULL, 0U);
#line 451 "../src/Services/PlaybackManager.vala"
	position = GTK_INVALID_LIST_POSITION;
#line 2121 "PlaybackManager.c"
	{
		guint i = 0U;
#line 452 "../src/Services/PlaybackManager.vala"
		i = (guint) 0;
#line 2126 "PlaybackManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 452 "../src/Services/PlaybackManager.vala"
			_tmp0_ = TRUE;
#line 452 "../src/Services/PlaybackManager.vala"
			while (TRUE) {
#line 2133 "PlaybackManager.c"
				GtkStringList* _tmp2_;
				GtkStringList* _tmp3_;
				const gchar* _tmp4_;
#line 452 "../src/Services/PlaybackManager.vala"
				if (!_tmp0_) {
#line 2139 "PlaybackManager.c"
					guint _tmp1_;
#line 452 "../src/Services/PlaybackManager.vala"
					_tmp1_ = i;
#line 452 "../src/Services/PlaybackManager.vala"
					i = _tmp1_ + 1;
#line 2145 "PlaybackManager.c"
				}
#line 452 "../src/Services/PlaybackManager.vala"
				_tmp0_ = FALSE;
#line 452 "../src/Services/PlaybackManager.vala"
				_tmp2_ = self->priv->_play_queue;
#line 452 "../src/Services/PlaybackManager.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp2_))) {
#line 452 "../src/Services/PlaybackManager.vala"
					break;
#line 2155 "PlaybackManager.c"
				}
#line 453 "../src/Services/PlaybackManager.vala"
				_tmp3_ = self->priv->_play_queue;
#line 453 "../src/Services/PlaybackManager.vala"
				_tmp4_ = gtk_string_list_get_string (_tmp3_, i);
#line 453 "../src/Services/PlaybackManager.vala"
				if (g_strcmp0 (_tmp4_, uri) == 0) {
#line 454 "../src/Services/PlaybackManager.vala"
					position = i;
#line 455 "../src/Services/PlaybackManager.vala"
					break;
#line 2167 "PlaybackManager.c"
				}
			}
		}
	}
#line 459 "../src/Services/PlaybackManager.vala"
	result = position;
#line 459 "../src/Services/PlaybackManager.vala"
	return result;
#line 2176 "PlaybackManager.c"
}

AudiencePlaybackManager*
audience_playback_manager_construct (GType object_type)
{
	AudiencePlaybackManager * self = NULL;
#line 6 "../src/Services/PlaybackManager.vala"
	self = (AudiencePlaybackManager*) g_object_new (object_type, NULL);
#line 6 "../src/Services/PlaybackManager.vala"
	return self;
#line 2187 "PlaybackManager.c"
}

AudiencePlaybackManager*
audience_playback_manager_new (void)
{
#line 6 "../src/Services/PlaybackManager.vala"
	return audience_playback_manager_construct (AUDIENCE_TYPE_PLAYBACK_MANAGER);
#line 2195 "PlaybackManager.c"
}

GdkPaintable*
audience_playback_manager_get_gst_video_widget (AudiencePlaybackManager* self)
{
	GdkPaintable* result;
	GdkPaintable* _tmp0_;
#line 12 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 12 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->_gst_video_widget;
#line 12 "../src/Services/PlaybackManager.vala"
	result = _tmp0_;
#line 12 "../src/Services/PlaybackManager.vala"
	return result;
#line 2211 "PlaybackManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 12 "../src/Services/PlaybackManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 2219 "PlaybackManager.c"
}

static void
audience_playback_manager_set_gst_video_widget (AudiencePlaybackManager* self,
                                                GdkPaintable* value)
{
	GdkPaintable* old_value;
#line 12 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/Services/PlaybackManager.vala"
	old_value = audience_playback_manager_get_gst_video_widget (self);
#line 12 "../src/Services/PlaybackManager.vala"
	if (old_value != value) {
#line 2233 "PlaybackManager.c"
		GdkPaintable* _tmp0_;
#line 12 "../src/Services/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 12 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_gst_video_widget);
#line 12 "../src/Services/PlaybackManager.vala"
		self->priv->_gst_video_widget = _tmp0_;
#line 12 "../src/Services/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_GST_VIDEO_WIDGET_PROPERTY]);
#line 2243 "PlaybackManager.c"
	}
}

const gchar*
audience_playback_manager_get_subtitle_uri (AudiencePlaybackManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 13 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->_subtitle_uri;
#line 13 "../src/Services/PlaybackManager.vala"
	result = _tmp0_;
#line 13 "../src/Services/PlaybackManager.vala"
	return result;
#line 2260 "PlaybackManager.c"
}

static void
audience_playback_manager_set_subtitle_uri (AudiencePlaybackManager* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 13 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/Services/PlaybackManager.vala"
	old_value = audience_playback_manager_get_subtitle_uri (self);
#line 13 "../src/Services/PlaybackManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2274 "PlaybackManager.c"
		gchar* _tmp0_;
#line 13 "../src/Services/PlaybackManager.vala"
		_tmp0_ = g_strdup (value);
#line 13 "../src/Services/PlaybackManager.vala"
		_g_free0 (self->priv->_subtitle_uri);
#line 13 "../src/Services/PlaybackManager.vala"
		self->priv->_subtitle_uri = _tmp0_;
#line 13 "../src/Services/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_SUBTITLE_URI_PROPERTY]);
#line 2284 "PlaybackManager.c"
	}
}

gboolean
audience_playback_manager_get_playing (AudiencePlaybackManager* self)
{
	gboolean result;
#line 14 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 14 "../src/Services/PlaybackManager.vala"
	result = self->priv->_playing;
#line 14 "../src/Services/PlaybackManager.vala"
	return result;
#line 2298 "PlaybackManager.c"
}

static void
audience_playback_manager_set_playing (AudiencePlaybackManager* self,
                                       gboolean value)
{
	gboolean old_value;
#line 14 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/Services/PlaybackManager.vala"
	old_value = audience_playback_manager_get_playing (self);
#line 14 "../src/Services/PlaybackManager.vala"
	if (old_value != value) {
#line 14 "../src/Services/PlaybackManager.vala"
		self->priv->_playing = value;
#line 14 "../src/Services/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
#line 2316 "PlaybackManager.c"
	}
}

gint64
audience_playback_manager_get_duration (AudiencePlaybackManager* self)
{
	gint64 result;
#line 15 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 15 "../src/Services/PlaybackManager.vala"
	result = self->priv->_duration;
#line 15 "../src/Services/PlaybackManager.vala"
	return result;
#line 2330 "PlaybackManager.c"
}

static void
audience_playback_manager_set_duration (AudiencePlaybackManager* self,
                                        gint64 value)
{
	gint64 old_value;
#line 15 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/Services/PlaybackManager.vala"
	old_value = audience_playback_manager_get_duration (self);
#line 15 "../src/Services/PlaybackManager.vala"
	if (old_value != value) {
#line 15 "../src/Services/PlaybackManager.vala"
		self->priv->_duration = value;
#line 15 "../src/Services/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_DURATION_PROPERTY]);
#line 2348 "PlaybackManager.c"
	}
}

gint64
audience_playback_manager_get_position (AudiencePlaybackManager* self)
{
	gint64 result;
#line 16 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 16 "../src/Services/PlaybackManager.vala"
	result = self->priv->_position;
#line 16 "../src/Services/PlaybackManager.vala"
	return result;
#line 2362 "PlaybackManager.c"
}

static void
audience_playback_manager_set_position (AudiencePlaybackManager* self,
                                        gint64 value)
{
	gint64 old_value;
#line 16 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/Services/PlaybackManager.vala"
	old_value = audience_playback_manager_get_position (self);
#line 16 "../src/Services/PlaybackManager.vala"
	if (old_value != value) {
#line 16 "../src/Services/PlaybackManager.vala"
		self->priv->_position = value;
#line 16 "../src/Services/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_POSITION_PROPERTY]);
#line 2380 "PlaybackManager.c"
	}
}

GtkStringList*
audience_playback_manager_get_play_queue (AudiencePlaybackManager* self)
{
	GtkStringList* result;
	GtkStringList* _tmp0_;
#line 18 "../src/Services/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->_play_queue;
#line 18 "../src/Services/PlaybackManager.vala"
	result = _tmp0_;
#line 18 "../src/Services/PlaybackManager.vala"
	return result;
#line 2397 "PlaybackManager.c"
}

static void
audience_playback_manager_set_play_queue (AudiencePlaybackManager* self,
                                          GtkStringList* value)
{
	GtkStringList* old_value;
#line 18 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/Services/PlaybackManager.vala"
	old_value = audience_playback_manager_get_play_queue (self);
#line 18 "../src/Services/PlaybackManager.vala"
	if (old_value != value) {
#line 2411 "PlaybackManager.c"
		GtkStringList* _tmp0_;
#line 18 "../src/Services/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_play_queue);
#line 18 "../src/Services/PlaybackManager.vala"
		self->priv->_play_queue = _tmp0_;
#line 18 "../src/Services/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_PLAY_QUEUE_PROPERTY]);
#line 2421 "PlaybackManager.c"
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 37 "../src/Services/PlaybackManager.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 37 "../src/Services/PlaybackManager.vala"
	return _data10_;
#line 2432 "PlaybackManager.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 37 "../src/Services/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2442 "PlaybackManager.c"
		AudiencePlaybackManager* self;
#line 37 "../src/Services/PlaybackManager.vala"
		self = _data10_->self;
#line 37 "../src/Services/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 37 "../src/Services/PlaybackManager.vala"
		g_slice_free (Block10Data, _data10_);
#line 2450 "PlaybackManager.c"
	}
}

static void
_audience_playback_manager_handle_bus_message_gst_bus_message (GstBus* _sender,
                                                               GstMessage* message,
                                                               gpointer self)
{
#line 50 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_handle_bus_message ((AudiencePlaybackManager*) self, message);
#line 2461 "PlaybackManager.c"
}

static void
_audience_playback_manager___lambda13_ (AudiencePlaybackManager* self)
{
	const gchar* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
#line 53 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->_subtitle_uri;
#line 53 "../src/Services/PlaybackManager.vala"
	_tmp1_ = self->priv->playbin;
#line 53 "../src/Services/PlaybackManager.vala"
	g_object_get (_tmp1_, "suburi", &_tmp2_, NULL);
#line 53 "../src/Services/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 53 "../src/Services/PlaybackManager.vala"
	if (g_strcmp0 (_tmp0_, (const gchar*) _tmp3_) != 0) {
#line 2481 "PlaybackManager.c"
		GstElement* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 54 "../src/Services/PlaybackManager.vala"
		_tmp4_ = self->priv->playbin;
#line 54 "../src/Services/PlaybackManager.vala"
		g_object_get (_tmp4_, "suburi", &_tmp5_, NULL);
#line 54 "../src/Services/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 54 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_subtitle_uri (self, _tmp6_);
#line 2493 "PlaybackManager.c"
	}
}

static void
__audience_playback_manager___lambda13__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 52 "../src/Services/PlaybackManager.vala"
	_audience_playback_manager___lambda13_ ((AudiencePlaybackManager*) self);
#line 2504 "PlaybackManager.c"
}

static void
_audience_playback_manager___lambda14_ (AudiencePlaybackManager* self)
{
	GstElement* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 59 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->playbin;
#line 59 "../src/Services/PlaybackManager.vala"
	g_object_get (_tmp0_, "uri", &_tmp1_, NULL);
#line 59 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 59 "../src/Services/PlaybackManager.vala"
	g_signal_emit (self, audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_URI_CHANGED_SIGNAL], 0, _tmp2_);
#line 2521 "PlaybackManager.c"
}

static void
__audience_playback_manager___lambda14__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 58 "../src/Services/PlaybackManager.vala"
	_audience_playback_manager___lambda14_ ((AudiencePlaybackManager*) self);
#line 2531 "PlaybackManager.c"
}

static void
_audience_playback_manager___lambda15_ (AudiencePlaybackManager* self,
                                        const gchar* name,
                                        GVariant* new_state)
{
#line 64 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (name != NULL);
#line 64 "../src/Services/PlaybackManager.vala"
	g_return_if_fail (new_state != NULL);
#line 65 "../src/Services/PlaybackManager.vala"
	if (g_strcmp0 (name, AUDIENCE_APP_ACTION_PLAY_PAUSE) == 0) {
#line 2545 "PlaybackManager.c"
		gboolean should_play = FALSE;
		gboolean _tmp0_;
#line 66 "../src/Services/PlaybackManager.vala"
		should_play = g_variant_get_boolean (new_state);
#line 68 "../src/Services/PlaybackManager.vala"
		_tmp0_ = self->priv->_playing;
#line 68 "../src/Services/PlaybackManager.vala"
		if (_tmp0_ != should_play) {
#line 2554 "PlaybackManager.c"
			GstState _tmp1_ = 0;
			GstElement* _tmp2_;
#line 69 "../src/Services/PlaybackManager.vala"
			if (should_play) {
#line 69 "../src/Services/PlaybackManager.vala"
				_tmp1_ = GST_STATE_PLAYING;
#line 2561 "PlaybackManager.c"
			} else {
#line 69 "../src/Services/PlaybackManager.vala"
				_tmp1_ = GST_STATE_PAUSED;
#line 2565 "PlaybackManager.c"
			}
#line 69 "../src/Services/PlaybackManager.vala"
			_tmp2_ = self->priv->playbin;
#line 69 "../src/Services/PlaybackManager.vala"
			gst_element_set_state (_tmp2_, _tmp1_);
#line 2571 "PlaybackManager.c"
		}
	}
}

static void
__audience_playback_manager___lambda15__g_action_group_action_state_changed (GActionGroup* _sender,
                                                                             const gchar* action_name,
                                                                             GVariant* state,
                                                                             gpointer self)
{
#line 64 "../src/Services/PlaybackManager.vala"
	_audience_playback_manager___lambda15_ ((AudiencePlaybackManager*) self, action_name, state);
#line 2584 "PlaybackManager.c"
}

static void
_audience_playback_manager_save_playlist_g_list_model_items_changed (GListModel* _sender,
                                                                     guint position,
                                                                     guint removed,
                                                                     guint added,
                                                                     gpointer self)
{
#line 74 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_save_playlist ((AudiencePlaybackManager*) self);
#line 2596 "PlaybackManager.c"
}

static GVariant*
_variant_new11 (gboolean value)
{
#line 78 "../src/Services/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2604 "PlaybackManager.c"
}

static void
_audience_playback_manager___lambda16_ (Block10Data* _data10_)
{
	AudiencePlaybackManager* self;
	GAction* play_pause_action = NULL;
	GtkApplication* _tmp0_;
	GAction* _tmp1_;
	GAction* _tmp2_;
	GAction* _tmp3_;
	gboolean _tmp4_;
	GVariant* _tmp5_;
#line 76 "../src/Services/PlaybackManager.vala"
	self = _data10_->self;
#line 77 "../src/Services/PlaybackManager.vala"
	_tmp0_ = _data10_->default_application;
#line 77 "../src/Services/PlaybackManager.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) _tmp0_, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 77 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 77 "../src/Services/PlaybackManager.vala"
	play_pause_action = _tmp2_;
#line 78 "../src/Services/PlaybackManager.vala"
	_tmp3_ = play_pause_action;
#line 78 "../src/Services/PlaybackManager.vala"
	_tmp4_ = self->priv->_playing;
#line 78 "../src/Services/PlaybackManager.vala"
	_tmp5_ = _variant_new11 (_tmp4_);
#line 78 "../src/Services/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), _tmp5_);
#line 78 "../src/Services/PlaybackManager.vala"
	_g_variant_unref0 (_tmp5_);
#line 79 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_update_position (self);
#line 76 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (play_pause_action);
#line 2642 "PlaybackManager.c"
}

static void
__audience_playback_manager___lambda16__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 76 "../src/Services/PlaybackManager.vala"
	_audience_playback_manager___lambda16_ (self);
#line 2652 "PlaybackManager.c"
}

static gboolean
_audience_playback_manager___lambda17_ (AudiencePlaybackManager* self)
{
	gboolean result;
#line 83 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_update_position (self);
#line 84 "../src/Services/PlaybackManager.vala"
	result = G_SOURCE_CONTINUE;
#line 84 "../src/Services/PlaybackManager.vala"
	return result;
#line 2665 "PlaybackManager.c"
}

static gboolean
__audience_playback_manager___lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = _audience_playback_manager___lambda17_ ((AudiencePlaybackManager*) self);
#line 82 "../src/Services/PlaybackManager.vala"
	return result;
#line 2675 "PlaybackManager.c"
}

static GObject *
audience_playback_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AudiencePlaybackManager * self;
	Block10Data* _data10_;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GtkStringList* _tmp4_;
	GtkStringList* _tmp5_;
	GstElement* gtksink = NULL;
	GstElement* _tmp6_;
	GdkPaintable* _gst_video_widget = NULL;
	GstElement* _tmp7_;
	GdkPaintable* _tmp8_ = NULL;
	GdkPaintable* _tmp9_;
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* _tmp12_;
	GstBus* bus = NULL;
	GstElement* _tmp13_;
	GstBus* _tmp14_;
	GstBus* _tmp15_;
	GstBus* _tmp16_;
	GstElement* _tmp17_;
	GstElement* _tmp18_;
	GApplication* _tmp19_;
	GtkApplication* _tmp20_;
	GtkStringList* _tmp21_;
#line 37 "../src/Services/PlaybackManager.vala"
	parent_class = G_OBJECT_CLASS (audience_playback_manager_parent_class);
#line 37 "../src/Services/PlaybackManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/Services/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManager);
#line 37 "../src/Services/PlaybackManager.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 37 "../src/Services/PlaybackManager.vala"
	_data10_->_ref_count_ = 1;
#line 37 "../src/Services/PlaybackManager.vala"
	_data10_->self = g_object_ref (self);
#line 38 "../src/Services/PlaybackManager.vala"
	_tmp0_ = audience_settings;
#line 38 "../src/Services/PlaybackManager.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "last-played-videos");
#line 38 "../src/Services/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 38 "../src/Services/PlaybackManager.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 38 "../src/Services/PlaybackManager.vala"
	_tmp4_ = gtk_string_list_new (_tmp3_);
#line 38 "../src/Services/PlaybackManager.vala"
	_tmp5_ = _tmp4_;
#line 38 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_set_play_queue (self, _tmp5_);
#line 38 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (_tmp5_);
#line 38 "../src/Services/PlaybackManager.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 40 "../src/Services/PlaybackManager.vala"
	_tmp6_ = gst_element_factory_make ("gtk4paintablesink", "sink");
#line 40 "../src/Services/PlaybackManager.vala"
	if (_tmp6_ != NULL) {
#line 40 "../src/Services/PlaybackManager.vala"
		g_object_ref_sink (_tmp6_);
#line 2749 "PlaybackManager.c"
	}
#line 40 "../src/Services/PlaybackManager.vala"
	gtksink = _tmp6_;
#line 42 "../src/Services/PlaybackManager.vala"
	_tmp7_ = gtksink;
#line 42 "../src/Services/PlaybackManager.vala"
	g_object_get ((GObject*) _tmp7_, "paintable", &_tmp8_, NULL);
#line 42 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (_gst_video_widget);
#line 42 "../src/Services/PlaybackManager.vala"
	_gst_video_widget = _tmp8_;
#line 43 "../src/Services/PlaybackManager.vala"
	_tmp9_ = _gst_video_widget;
#line 43 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_set_gst_video_widget (self, _tmp9_);
#line 45 "../src/Services/PlaybackManager.vala"
	_tmp10_ = gst_element_factory_make ("playbin", "bin");
#line 45 "../src/Services/PlaybackManager.vala"
	if (_tmp10_ != NULL) {
#line 45 "../src/Services/PlaybackManager.vala"
		g_object_ref_sink (_tmp10_);
#line 2771 "PlaybackManager.c"
	}
#line 45 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbin);
#line 45 "../src/Services/PlaybackManager.vala"
	self->priv->playbin = _tmp10_;
#line 46 "../src/Services/PlaybackManager.vala"
	_tmp11_ = self->priv->playbin;
#line 46 "../src/Services/PlaybackManager.vala"
	_tmp12_ = gtksink;
#line 46 "../src/Services/PlaybackManager.vala"
	g_object_set (_tmp11_, "video-sink", _tmp12_, NULL);
#line 48 "../src/Services/PlaybackManager.vala"
	_tmp13_ = self->priv->playbin;
#line 48 "../src/Services/PlaybackManager.vala"
	_tmp14_ = gst_element_get_bus (_tmp13_);
#line 48 "../src/Services/PlaybackManager.vala"
	bus = _tmp14_;
#line 49 "../src/Services/PlaybackManager.vala"
	_tmp15_ = bus;
#line 49 "../src/Services/PlaybackManager.vala"
	gst_bus_add_signal_watch_full (_tmp15_, G_PRIORITY_DEFAULT);
#line 50 "../src/Services/PlaybackManager.vala"
	_tmp16_ = bus;
#line 50 "../src/Services/PlaybackManager.vala"
	g_signal_connect_object (_tmp16_, "message", (GCallback) _audience_playback_manager_handle_bus_message_gst_bus_message, self, 0);
#line 52 "../src/Services/PlaybackManager.vala"
	_tmp17_ = self->priv->playbin;
#line 52 "../src/Services/PlaybackManager.vala"
	g_signal_connect_object ((GObject*) _tmp17_, "notify::suburi", (GCallback) __audience_playback_manager___lambda13__g_object_notify, self, 0);
#line 58 "../src/Services/PlaybackManager.vala"
	_tmp18_ = self->priv->playbin;
#line 58 "../src/Services/PlaybackManager.vala"
	g_signal_connect_object ((GObject*) _tmp18_, "notify::uri", (GCallback) __audience_playback_manager___lambda14__g_object_notify, self, 0);
#line 62 "../src/Services/PlaybackManager.vala"
	_tmp19_ = g_application_get_default ();
#line 62 "../src/Services/PlaybackManager.vala"
	_data10_->default_application = G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_application_get_type (), GtkApplication);
#line 64 "../src/Services/PlaybackManager.vala"
	_tmp20_ = _data10_->default_application;
#line 64 "../src/Services/PlaybackManager.vala"
	g_signal_connect_object ((GActionGroup*) _tmp20_, "action-state-changed", (GCallback) __audience_playback_manager___lambda15__g_action_group_action_state_changed, self, 0);
#line 74 "../src/Services/PlaybackManager.vala"
	_tmp21_ = self->priv->_play_queue;
#line 74 "../src/Services/PlaybackManager.vala"
	g_signal_connect_object ((GListModel*) _tmp21_, "items-changed", (GCallback) _audience_playback_manager_save_playlist_g_list_model_items_changed, self, 0);
#line 76 "../src/Services/PlaybackManager.vala"
	g_signal_connect_data ((GObject*) self, "notify::playing", (GCallback) __audience_playback_manager___lambda16__g_object_notify, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 82 "../src/Services/PlaybackManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, __audience_playback_manager___lambda17__gsource_func, g_object_ref (self), g_object_unref);
#line 37 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (bus);
#line 37 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (_gst_video_widget);
#line 37 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (gtksink);
#line 37 "../src/Services/PlaybackManager.vala"
	block10_data_unref (_data10_);
#line 37 "../src/Services/PlaybackManager.vala"
	_data10_ = NULL;
#line 37 "../src/Services/PlaybackManager.vala"
	return obj;
#line 2833 "PlaybackManager.c"
}

static void
audience_playback_manager_class_init (AudiencePlaybackManagerClass * klass,
                                      gpointer klass_data)
{
#line 6 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Services/PlaybackManager.vala"
	g_type_class_adjust_private_offset (klass, &AudiencePlaybackManager_private_offset);
#line 6 "../src/Services/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_audience_playback_manager_get_property;
#line 6 "../src/Services/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_audience_playback_manager_set_property;
#line 6 "../src/Services/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->constructor = audience_playback_manager_constructor;
#line 6 "../src/Services/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->finalize = audience_playback_manager_finalize;
#line 6 "../src/Services/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_PLAYBACK_MANAGER_GST_VIDEO_WIDGET_PROPERTY, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_GST_VIDEO_WIDGET_PROPERTY] = g_param_spec_object ("gst-video-widget", "gst-video-widget", "gst-video-widget", gdk_paintable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/Services/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_PLAYBACK_MANAGER_SUBTITLE_URI_PROPERTY, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_SUBTITLE_URI_PROPERTY] = g_param_spec_string ("subtitle-uri", "subtitle-uri", "subtitle-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/Services/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_PLAYBACK_MANAGER_PLAYING_PROPERTY, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/Services/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_PLAYBACK_MANAGER_DURATION_PROPERTY, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_DURATION_PROPERTY] = g_param_spec_int64 ("duration", "duration", "duration", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/Services/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_PLAYBACK_MANAGER_POSITION_PROPERTY, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_POSITION_PROPERTY] = g_param_spec_int64 ("position", "position", "position", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/Services/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_PLAYBACK_MANAGER_PLAY_QUEUE_PROPERTY, audience_playback_manager_properties[AUDIENCE_PLAYBACK_MANAGER_PLAY_QUEUE_PROPERTY] = g_param_spec_object ("play-queue", "play-queue", "play-queue", gtk_string_list_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_ENDED_SIGNAL] = g_signal_new ("ended", AUDIENCE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 6 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_NEXT_AUDIO_SIGNAL] = g_signal_new ("next-audio", AUDIENCE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 6 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_NEXT_TEXT_SIGNAL] = g_signal_new ("next-text", AUDIENCE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 6 "../src/Services/PlaybackManager.vala"
	audience_playback_manager_signals[AUDIENCE_PLAYBACK_MANAGER_URI_CHANGED_SIGNAL] = g_signal_new ("uri-changed", AUDIENCE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 2872 "PlaybackManager.c"
}

static void
audience_playback_manager_instance_init (AudiencePlaybackManager * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
#line 6 "../src/Services/PlaybackManager.vala"
	self->priv = audience_playback_manager_get_instance_private (self);
#line 13 "../src/Services/PlaybackManager.vala"
	_tmp0_ = g_strdup ("");
#line 13 "../src/Services/PlaybackManager.vala"
	self->priv->_subtitle_uri = _tmp0_;
#line 15 "../src/Services/PlaybackManager.vala"
	self->priv->_duration = (gint64) 0;
#line 16 "../src/Services/PlaybackManager.vala"
	self->priv->_position = (gint64) 0;
#line 27 "../src/Services/PlaybackManager.vala"
	self->priv->is_seeking = FALSE;
#line 28 "../src/Services/PlaybackManager.vala"
	self->priv->queued_seek = (gint64) -1;
#line 30 "../src/Services/PlaybackManager.vala"
	self->priv->inhibit_token = (guint) 0;
#line 2896 "PlaybackManager.c"
}

static void
audience_playback_manager_finalize (GObject * obj)
{
	AudiencePlaybackManager * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
#line 6 "../src/Services/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManager);
#line 89 "../src/Services/PlaybackManager.vala"
	_tmp0_ = self->priv->_duration;
#line 89 "../src/Services/PlaybackManager.vala"
	_tmp1_ = self->priv->_position;
#line 89 "../src/Services/PlaybackManager.vala"
	if (_tmp0_ == _tmp1_) {
#line 2913 "PlaybackManager.c"
		GSettings* _tmp2_;
#line 90 "../src/Services/PlaybackManager.vala"
		_tmp2_ = audience_settings;
#line 90 "../src/Services/PlaybackManager.vala"
		g_settings_set_int64 (_tmp2_, "last-stopped", (gint64) 0);
#line 2919 "PlaybackManager.c"
	} else {
		GstElement* _tmp3_;
		GstElement* _tmp4_;
		GstElement* _tmp5_;
#line 91 "../src/Services/PlaybackManager.vala"
		_tmp3_ = self->priv->playbin;
#line 91 "../src/Services/PlaybackManager.vala"
		g_object_get (_tmp3_, "current-uri", &_tmp4_, NULL);
#line 91 "../src/Services/PlaybackManager.vala"
		_tmp5_ = _tmp4_;
#line 91 "../src/Services/PlaybackManager.vala"
		if (g_strcmp0 ((const gchar*) _tmp5_, "") != 0) {
#line 2932 "PlaybackManager.c"
			GSettings* _tmp6_;
			gint64 _tmp7_;
#line 94 "../src/Services/PlaybackManager.vala"
			_tmp6_ = audience_settings;
#line 94 "../src/Services/PlaybackManager.vala"
			_tmp7_ = self->priv->_position;
#line 94 "../src/Services/PlaybackManager.vala"
			g_settings_set_int64 (_tmp6_, "last-stopped", _tmp7_);
#line 2941 "PlaybackManager.c"
		}
	}
#line 97 "../src/Services/PlaybackManager.vala"
	if (self->priv->inhibit_token != ((guint) 0)) {
#line 2946 "PlaybackManager.c"
		GApplication* _tmp8_;
#line 98 "../src/Services/PlaybackManager.vala"
		_tmp8_ = g_application_get_default ();
#line 98 "../src/Services/PlaybackManager.vala"
		gtk_application_uninhibit (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_application_get_type (), GtkApplication), self->priv->inhibit_token);
#line 99 "../src/Services/PlaybackManager.vala"
		self->priv->inhibit_token = (guint) 0;
#line 2954 "PlaybackManager.c"
	}
#line 12 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_gst_video_widget);
#line 13 "../src/Services/PlaybackManager.vala"
	_g_free0 (self->priv->_subtitle_uri);
#line 18 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_play_queue);
#line 26 "../src/Services/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbin);
#line 6 "../src/Services/PlaybackManager.vala"
	G_OBJECT_CLASS (audience_playback_manager_parent_class)->finalize (obj);
#line 2966 "PlaybackManager.c"
}

static GType
audience_playback_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AudiencePlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) audience_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AudiencePlaybackManager), 0, (GInstanceInitFunc) audience_playback_manager_instance_init, NULL };
	GType audience_playback_manager_type_id;
	audience_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "AudiencePlaybackManager", &g_define_type_info, 0);
	AudiencePlaybackManager_private_offset = g_type_add_instance_private (audience_playback_manager_type_id, sizeof (AudiencePlaybackManagerPrivate));
	return audience_playback_manager_type_id;
}

GType
audience_playback_manager_get_type (void)
{
	static volatile gsize audience_playback_manager_type_id__once = 0;
	if (g_once_init_enter (&audience_playback_manager_type_id__once)) {
		GType audience_playback_manager_type_id;
		audience_playback_manager_type_id = audience_playback_manager_get_type_once ();
		g_once_init_leave (&audience_playback_manager_type_id__once, audience_playback_manager_type_id);
	}
	return audience_playback_manager_type_id__once;
}

static void
_vala_audience_playback_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	AudiencePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManager);
#line 6 "../src/Services/PlaybackManager.vala"
	switch (property_id) {
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_GST_VIDEO_WIDGET_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		g_value_set_object (value, audience_playback_manager_get_gst_video_widget (self));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_SUBTITLE_URI_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		g_value_set_string (value, audience_playback_manager_get_subtitle_uri (self));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		g_value_set_boolean (value, audience_playback_manager_get_playing (self));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_DURATION_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		g_value_set_int64 (value, audience_playback_manager_get_duration (self));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_POSITION_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		g_value_set_int64 (value, audience_playback_manager_get_position (self));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_PLAY_QUEUE_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		g_value_set_object (value, audience_playback_manager_get_play_queue (self));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 3037 "PlaybackManager.c"
		default:
#line 6 "../src/Services/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 3043 "PlaybackManager.c"
	}
}

static void
_vala_audience_playback_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	AudiencePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManager);
#line 6 "../src/Services/PlaybackManager.vala"
	switch (property_id) {
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_GST_VIDEO_WIDGET_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_gst_video_widget (self, g_value_get_object (value));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_SUBTITLE_URI_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_subtitle_uri (self, g_value_get_string (value));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_playing (self, g_value_get_boolean (value));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_DURATION_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_duration (self, g_value_get_int64 (value));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_POSITION_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_position (self, g_value_get_int64 (value));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 6 "../src/Services/PlaybackManager.vala"
		case AUDIENCE_PLAYBACK_MANAGER_PLAY_QUEUE_PROPERTY:
#line 6 "../src/Services/PlaybackManager.vala"
		audience_playback_manager_set_play_queue (self, g_value_get_object (value));
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 3093 "PlaybackManager.c"
		default:
#line 6 "../src/Services/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Services/PlaybackManager.vala"
		break;
#line 3099 "PlaybackManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

