/* Window.c generated by valac 0.56.17, the Vala compiler
 * generated from Window.vala, do not modify */

/*-
 * Copyright (c) 2013-2019 elementary Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Tom Beckmann <tomjonabc@gmail.com>
 *              Cody Garver <cody@elementaryos.org>
 *              Artem Anufrij <artem.anufrij@live.de>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <adwaita.h>
#include <granite-7.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define AUDIENCE_WINDOW_ACTION_GROUP_PREFIX "win"
#define AUDIENCE_WINDOW_ACTION_PREFIX AUDIENCE_WINDOW_ACTION_GROUP_PREFIX "."
#define AUDIENCE_WINDOW_ACTION_BACK "back"
#define AUDIENCE_WINDOW_ACTION_FULLSCREEN "action-fullscreen"
#define AUDIENCE_WINDOW_ACTION_OPEN_FILE "action-open-file"
#define AUDIENCE_WINDOW_ACTION_QUIT "action-quit"
#define AUDIENCE_WINDOW_ACTION_SEARCH "action-search"
#define AUDIENCE_WINDOW_ACTION_UNDO "action-undo"
#define AUDIENCE_APP_ACTION_PLAY_PAUSE "action-play-pause"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define AUDIENCE_TYPE_WINDOW (audience_window_get_type ())
#define AUDIENCE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindow))
#define AUDIENCE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))
#define AUDIENCE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))

typedef struct _AudienceWindow AudienceWindow;
typedef struct _AudienceWindowClass AudienceWindowClass;
typedef struct _AudienceWindowPrivate AudienceWindowPrivate;

#define AUDIENCE_TYPE_EPISODES_PAGE (audience_episodes_page_get_type ())
#define AUDIENCE_EPISODES_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_EPISODES_PAGE, AudienceEpisodesPage))
#define AUDIENCE_EPISODES_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_EPISODES_PAGE, AudienceEpisodesPageClass))
#define AUDIENCE_IS_EPISODES_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_EPISODES_PAGE))
#define AUDIENCE_IS_EPISODES_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_EPISODES_PAGE))
#define AUDIENCE_EPISODES_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_EPISODES_PAGE, AudienceEpisodesPageClass))

typedef struct _AudienceEpisodesPage AudienceEpisodesPage;
typedef struct _AudienceEpisodesPageClass AudienceEpisodesPageClass;

#define AUDIENCE_TYPE_LIBRARY_PAGE (audience_library_page_get_type ())
#define AUDIENCE_LIBRARY_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_LIBRARY_PAGE, AudienceLibraryPage))
#define AUDIENCE_LIBRARY_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_LIBRARY_PAGE, AudienceLibraryPageClass))
#define AUDIENCE_IS_LIBRARY_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_LIBRARY_PAGE))
#define AUDIENCE_IS_LIBRARY_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_LIBRARY_PAGE))
#define AUDIENCE_LIBRARY_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_LIBRARY_PAGE, AudienceLibraryPageClass))

typedef struct _AudienceLibraryPage AudienceLibraryPage;
typedef struct _AudienceLibraryPageClass AudienceLibraryPageClass;

#define AUDIENCE_TYPE_PLAYER_PAGE (audience_player_page_get_type ())
#define AUDIENCE_PLAYER_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_PLAYER_PAGE, AudiencePlayerPage))
#define AUDIENCE_PLAYER_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_PLAYER_PAGE, AudiencePlayerPageClass))
#define AUDIENCE_IS_PLAYER_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_PLAYER_PAGE))
#define AUDIENCE_IS_PLAYER_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_PLAYER_PAGE))
#define AUDIENCE_PLAYER_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_PLAYER_PAGE, AudiencePlayerPageClass))

typedef struct _AudiencePlayerPage AudiencePlayerPage;
typedef struct _AudiencePlayerPageClass AudiencePlayerPageClass;

#define AUDIENCE_TYPE_WELCOME_PAGE (audience_welcome_page_get_type ())
#define AUDIENCE_WELCOME_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_WELCOME_PAGE, AudienceWelcomePage))
#define AUDIENCE_WELCOME_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_WELCOME_PAGE, AudienceWelcomePageClass))
#define AUDIENCE_IS_WELCOME_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_WELCOME_PAGE))
#define AUDIENCE_IS_WELCOME_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_WELCOME_PAGE))
#define AUDIENCE_WELCOME_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_WELCOME_PAGE, AudienceWelcomePageClass))

typedef struct _AudienceWelcomePage AudienceWelcomePage;
typedef struct _AudienceWelcomePageClass AudienceWelcomePageClass;
enum  {
	AUDIENCE_WINDOW_0_PROPERTY,
	AUDIENCE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* audience_window_properties[AUDIENCE_WINDOW_NUM_PROPERTIES];
typedef enum  {
	AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME,
	AUDIENCE_WINDOW_NAVIGATION_PAGE_LIBRARY,
	AUDIENCE_WINDOW_NAVIGATION_PAGE_EPISODES
} AudienceWindowNavigationPage;

#define AUDIENCE_WINDOW_TYPE_NAVIGATION_PAGE (audience_window_navigation_page_get_type ())
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER (audience_services_library_manager_get_type ())
#define AUDIENCE_SERVICES_LIBRARY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER, AudienceServicesLibraryManager))
#define AUDIENCE_SERVICES_LIBRARY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER, AudienceServicesLibraryManagerClass))
#define AUDIENCE_SERVICES_IS_LIBRARY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER))
#define AUDIENCE_SERVICES_IS_LIBRARY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER))
#define AUDIENCE_SERVICES_LIBRARY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER, AudienceServicesLibraryManagerClass))

typedef struct _AudienceServicesLibraryManager AudienceServicesLibraryManager;
typedef struct _AudienceServicesLibraryManagerClass AudienceServicesLibraryManagerClass;

#define AUDIENCE_TYPE_PLAYBACK_MANAGER (audience_playback_manager_get_type ())
#define AUDIENCE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManager))
#define AUDIENCE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManagerClass))
#define AUDIENCE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_PLAYBACK_MANAGER))
#define AUDIENCE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_PLAYBACK_MANAGER))
#define AUDIENCE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_PLAYBACK_MANAGER, AudiencePlaybackManagerClass))

typedef struct _AudiencePlaybackManager AudiencePlaybackManager;
typedef struct _AudiencePlaybackManagerClass AudiencePlaybackManagerClass;
typedef struct _Block2Data Block2Data;
typedef void (*AudienceFuncOverDir) (GFile* file_under_dir, gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block4Data Block4Data;

#define AUDIENCE_OBJECTS_TYPE_MEDIA_ITEM (audience_objects_media_item_get_type ())
#define AUDIENCE_OBJECTS_MEDIA_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_OBJECTS_TYPE_MEDIA_ITEM, AudienceObjectsMediaItem))
#define AUDIENCE_OBJECTS_MEDIA_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_OBJECTS_TYPE_MEDIA_ITEM, AudienceObjectsMediaItemClass))
#define AUDIENCE_OBJECTS_IS_MEDIA_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_OBJECTS_TYPE_MEDIA_ITEM))
#define AUDIENCE_OBJECTS_IS_MEDIA_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_OBJECTS_TYPE_MEDIA_ITEM))
#define AUDIENCE_OBJECTS_MEDIA_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_OBJECTS_TYPE_MEDIA_ITEM, AudienceObjectsMediaItemClass))

typedef struct _AudienceObjectsMediaItem AudienceObjectsMediaItem;
typedef struct _AudienceObjectsMediaItemClass AudienceObjectsMediaItemClass;
enum  {
	AUDIENCE_WINDOW_MEDIA_VOLUMES_CHANGED_SIGNAL,
	AUDIENCE_WINDOW_NUM_SIGNALS
};
static guint audience_window_signals[AUDIENCE_WINDOW_NUM_SIGNALS] = {0};

struct _AudienceWindow {
	GtkApplicationWindow parent_instance;
	AudienceWindowPrivate * priv;
};

struct _AudienceWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _AudienceWindowPrivate {
	AdwNavigationView* navigation_view;
	GraniteToast* app_notification;
	AudienceEpisodesPage* episodes_page;
	AudienceLibraryPage* library_page;
	AudiencePlayerPage* player_page;
	AudienceWelcomePage* welcome_page;
};

struct _Block2Data {
	int _ref_count_;
	AudienceWindow* self;
	gchar** videos;
	gint videos_length1;
	gint _videos_size_;
};

struct _Block3Data {
	int _ref_count_;
	AudienceWindow* self;
	GtkFileChooserNative* file;
	gboolean clear_playlist;
	gboolean force_play;
};

struct _Block4Data {
	int _ref_count_;
	AudienceWindow* self;
	AudiencePlaybackManager* playback_manager;
};

static gint AudienceWindow_private_offset;
static gpointer audience_window_parent_class = NULL;
static GeeMultiMap* audience_window_action_accelerators;
static GeeMultiMap* audience_window_action_accelerators = NULL;
VALA_EXTERN GSettings* audience_settings;

VALA_EXTERN GType audience_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceWindow, g_object_unref)
VALA_EXTERN GType audience_episodes_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceEpisodesPage, g_object_unref)
VALA_EXTERN GType audience_library_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceLibraryPage, g_object_unref)
VALA_EXTERN GType audience_player_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudiencePlayerPage, g_object_unref)
VALA_EXTERN GType audience_welcome_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceWelcomePage, g_object_unref)
VALA_EXTERN GType audience_window_navigation_page_get_type (void) G_GNUC_CONST ;
static void audience_window_action_back (AudienceWindow* self);
static void _audience_window_action_back_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void audience_window_action_fullscreen (AudienceWindow* self);
static void _audience_window_action_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void audience_window_action_open_file (AudienceWindow* self);
static void _audience_window_action_open_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void audience_window_action_quit (AudienceWindow* self);
static void _audience_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void audience_window_action_search (AudienceWindow* self);
static void _audience_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void audience_window_action_undo (AudienceWindow* self);
static void _audience_window_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
VALA_EXTERN void audience_window_run_open_file (AudienceWindow* self,
                                    gboolean clear_playlist,
                                    gboolean force_play);
VALA_EXTERN void audience_library_page_search (AudienceLibraryPage* self);
VALA_EXTERN void audience_episodes_page_search (AudienceEpisodesPage* self);
VALA_EXTERN gboolean audience_is_sandboxed (void);
VALA_EXTERN GType audience_services_library_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceServicesLibraryManager, g_object_unref)
VALA_EXTERN AudienceServicesLibraryManager* audience_services_library_manager_get_instance (void);
VALA_EXTERN void audience_services_library_manager_undo_delete_item (AudienceServicesLibraryManager* self);
VALA_EXTERN gboolean audience_window_match_keycode (AudienceWindow* self,
                                        guint keyval,
                                        guint code);
VALA_EXTERN void audience_window_handle_key_press (AudienceWindow* self,
                                       guint keyval,
                                       guint keycode,
                                       GdkModifierType state);
VALA_EXTERN GType audience_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudiencePlaybackManager, g_object_unref)
VALA_EXTERN AudiencePlaybackManager* audience_playback_manager_get_default (void);
VALA_EXTERN void audience_player_page_seek_jump_seconds (AudiencePlayerPage* self,
                                             gint seconds);
VALA_EXTERN void audience_window_resume_last_videos (AudienceWindow* self);
VALA_EXTERN void audience_window_show_library (AudienceWindow* self);
VALA_EXTERN void audience_window_open_files (AudienceWindow* self,
                                 GFile** files,
                                 gint files_length1,
                                 gboolean clear_playlist_items,
                                 gboolean force_play);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN void audience_playback_manager_clear_playlist (AudiencePlaybackManager* self,
                                               gboolean should_stop);
VALA_EXTERN void audience_recurse_over_dir (GFile* file_to_process,
                                AudienceFuncOverDir func,
                                gpointer func_target);
static void _____lambda27_ (Block2Data* _data2_,
                     GFile* file_ret);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ______lambda27__audience_func_over_dir (GFile* file_under_dir,
                                             gpointer self);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void audience_playback_manager_append_to_playlist (AudiencePlaybackManager* self,
                                                   gchar** uris,
                                                   gint uris_length1);
VALA_EXTERN AudienceWindowNavigationPage audience_library_page_prepare_to_play (AudienceLibraryPage* self,
                                                                    const gchar* file);
VALA_EXTERN void audience_window_play_file (AudienceWindow* self,
                                const gchar* uri,
                                AudienceWindowNavigationPage origin,
                                gboolean from_beginning);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda26_ (Block3Data* _data3_,
                  gint response);
static void _vala_array_add3 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
static void ___lambda26__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static void audience_window_on_player_ended (AudienceWindow* self);
VALA_EXTERN void audience_playback_manager_play_file (AudiencePlaybackManager* self,
                                          const gchar* uri,
                                          gboolean from_beginning);
static void audience_window_update_navigation (AudienceWindow* self);
VALA_EXTERN gint64 audience_playback_manager_get_position (AudiencePlaybackManager* self);
static GVariant* _variant_new3 (gboolean value);
static GVariant* _variant_new4 (gboolean value);
VALA_EXTERN AudienceWindow* audience_window_new (void);
VALA_EXTERN AudienceWindow* audience_window_construct (GType object_type);
static GObject * audience_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN AudienceLibraryPage* audience_library_page_get_instance (void);
VALA_EXTERN AudienceWelcomePage* audience_welcome_page_new (void);
VALA_EXTERN AudienceWelcomePage* audience_welcome_page_construct (GType object_type);
VALA_EXTERN AudiencePlayerPage* audience_player_page_new (void);
VALA_EXTERN AudiencePlayerPage* audience_player_page_construct (GType object_type);
VALA_EXTERN AudienceEpisodesPage* audience_episodes_page_new (void);
VALA_EXTERN AudienceEpisodesPage* audience_episodes_page_construct (GType object_type);
VALA_EXTERN GType audience_objects_media_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceObjectsMediaItem, g_object_unref)
static void _audience_window___lambda72_ (AudienceWindow* self,
                                   AudienceObjectsMediaItem* item);
VALA_EXTERN const gchar* audience_objects_media_item_get_title (AudienceObjectsMediaItem* self);
static void _audience_window_action_undo_granite_toast_default_action (GraniteToast* _sender,
                                                                gpointer self);
static void __audience_window___lambda72__audience_services_library_manager_media_item_trashed (AudienceServicesLibraryManager* _sender,
                                                                                         AudienceObjectsMediaItem* item,
                                                                                         gpointer self);
static void _audience_window___lambda73_ (AudienceWindow* self,
                                   AudienceObjectsMediaItem* item,
                                   gboolean setup_only);
VALA_EXTERN void audience_episodes_page_set_show (AudienceEpisodesPage* self,
                                      AudienceObjectsMediaItem* item);
static void __audience_window___lambda73__audience_library_page_show_episodes (AudienceLibraryPage* _sender,
                                                                        AudienceObjectsMediaItem* item,
                                                                        gboolean setup_only,
                                                                        gpointer self);
static void _audience_window___lambda74_ (AudienceWindow* self);
static void __audience_window___lambda74__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
VALA_EXTERN GtkStringList* audience_playback_manager_get_play_queue (AudiencePlaybackManager* self);
static void _audience_window___lambda75_ (Block4Data* _data4_,
                                   guint pos,
                                   guint removed,
                                   guint added);
VALA_EXTERN gchar* audience_get_title (const gchar* filename);
static void __audience_window___lambda75__g_list_model_items_changed (GListModel* _sender,
                                                               guint position,
                                                               guint removed,
                                                               guint added,
                                                               gpointer self);
static void _audience_window_on_player_ended_audience_playback_manager_ended (AudiencePlaybackManager* _sender,
                                                                       gpointer self);
static void _audience_window_handle_key_press_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                              guint keyval,
                                                                              guint keycode,
                                                                              GdkModifierType state,
                                                                              gpointer self);
static gboolean _audience_window___lambda76_ (AudienceWindow* self,
                                       GValue* val);
static void _vala_array_add4 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
static gboolean __audience_window___lambda76__gtk_drop_target_drop (GtkDropTarget* _sender,
                                                             GValue* value,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self);
static void audience_window_finalize (GObject * obj);
static GType audience_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry AUDIENCE_WINDOW_ACTION_ENTRIES[6] = {{AUDIENCE_WINDOW_ACTION_BACK, _audience_window_action_back_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_FULLSCREEN, _audience_window_action_fullscreen_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_OPEN_FILE, _audience_window_action_open_file_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_QUIT, _audience_window_action_quit_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_SEARCH, _audience_window_action_search_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_UNDO, _audience_window_action_undo_gsimple_action_activate_callback}};

static inline gpointer
audience_window_get_instance_private (AudienceWindow* self)
{
	return G_STRUCT_MEMBER_P (self, AudienceWindow_private_offset);
}

static GType
audience_window_navigation_page_get_type_once (void)
{
	static const GEnumValue values[] = {{AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME, "AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME", "welcome"}, {AUDIENCE_WINDOW_NAVIGATION_PAGE_LIBRARY, "AUDIENCE_WINDOW_NAVIGATION_PAGE_LIBRARY", "library"}, {AUDIENCE_WINDOW_NAVIGATION_PAGE_EPISODES, "AUDIENCE_WINDOW_NAVIGATION_PAGE_EPISODES", "episodes"}, {0, NULL, NULL}};
	GType audience_window_navigation_page_type_id;
	audience_window_navigation_page_type_id = g_enum_register_static ("AudienceWindowNavigationPage", values);
	return audience_window_navigation_page_type_id;
}

GType
audience_window_navigation_page_get_type (void)
{
	static volatile gsize audience_window_navigation_page_type_id__once = 0;
	if (g_once_init_enter (&audience_window_navigation_page_type_id__once)) {
		GType audience_window_navigation_page_type_id;
		audience_window_navigation_page_type_id = audience_window_navigation_page_get_type_once ();
		g_once_init_leave (&audience_window_navigation_page_type_id__once, audience_window_navigation_page_type_id);
	}
	return audience_window_navigation_page_type_id__once;
}

static void
_audience_window_action_back_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 46 "../src/Window.vala"
	audience_window_action_back ((AudienceWindow*) self);
#line 443 "Window.c"
}

static void
_audience_window_action_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 46 "../src/Window.vala"
	audience_window_action_fullscreen ((AudienceWindow*) self);
#line 453 "Window.c"
}

static void
_audience_window_action_open_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 46 "../src/Window.vala"
	audience_window_action_open_file ((AudienceWindow*) self);
#line 463 "Window.c"
}

static void
_audience_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 46 "../src/Window.vala"
	audience_window_action_quit ((AudienceWindow*) self);
#line 473 "Window.c"
}

static void
_audience_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 46 "../src/Window.vala"
	audience_window_action_search ((AudienceWindow*) self);
#line 483 "Window.c"
}

static void
_audience_window_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 46 "../src/Window.vala"
	audience_window_action_undo ((AudienceWindow*) self);
#line 493 "Window.c"
}

static void
audience_window_action_back (AudienceWindow* self)
{
	AdwNavigationView* _tmp0_;
#line 173 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/Window.vala"
	_tmp0_ = self->priv->navigation_view;
#line 174 "../src/Window.vala"
	adw_navigation_view_pop (_tmp0_);
#line 506 "Window.c"
}

static void
audience_window_action_fullscreen (AudienceWindow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 177 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/Window.vala"
	g_object_get ((GtkWindow*) self, "fullscreened", &_tmp0_, NULL);
#line 178 "../src/Window.vala"
	_tmp1_ = _tmp0_;
#line 178 "../src/Window.vala"
	if (_tmp1_) {
#line 179 "../src/Window.vala"
		gtk_window_unfullscreen ((GtkWindow*) self);
#line 524 "Window.c"
	} else {
#line 181 "../src/Window.vala"
		gtk_window_fullscreen ((GtkWindow*) self);
#line 528 "Window.c"
	}
}

static void
audience_window_action_open_file (AudienceWindow* self)
{
#line 185 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/Window.vala"
	audience_window_run_open_file (self, FALSE, TRUE);
#line 539 "Window.c"
}

static void
audience_window_action_quit (AudienceWindow* self)
{
#line 189 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/Window.vala"
	gtk_window_destroy ((GtkWindow*) self);
#line 549 "Window.c"
}

static void
audience_window_action_search (AudienceWindow* self)
{
	AdwNavigationView* _tmp0_;
	AdwNavigationPage* _tmp1_;
	AdwNavigationPage* _tmp2_;
	AudienceLibraryPage* _tmp3_;
#line 193 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/Window.vala"
	_tmp0_ = self->priv->navigation_view;
#line 194 "../src/Window.vala"
	_tmp1_ = adw_navigation_view_get_visible_page (_tmp0_);
#line 194 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 194 "../src/Window.vala"
	_tmp3_ = self->priv->library_page;
#line 194 "../src/Window.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, adw_navigation_page_get_type (), AdwNavigationPage)) {
#line 571 "Window.c"
		AudienceLibraryPage* _tmp4_;
#line 195 "../src/Window.vala"
		_tmp4_ = self->priv->library_page;
#line 195 "../src/Window.vala"
		audience_library_page_search (_tmp4_);
#line 577 "Window.c"
	} else {
		AdwNavigationView* _tmp5_;
		AdwNavigationPage* _tmp6_;
		AdwNavigationPage* _tmp7_;
		AudienceEpisodesPage* _tmp8_;
#line 196 "../src/Window.vala"
		_tmp5_ = self->priv->navigation_view;
#line 196 "../src/Window.vala"
		_tmp6_ = adw_navigation_view_get_visible_page (_tmp5_);
#line 196 "../src/Window.vala"
		_tmp7_ = _tmp6_;
#line 196 "../src/Window.vala"
		_tmp8_ = self->priv->episodes_page;
#line 196 "../src/Window.vala"
		if (_tmp7_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, adw_navigation_page_get_type (), AdwNavigationPage)) {
#line 593 "Window.c"
			AudienceEpisodesPage* _tmp9_;
#line 197 "../src/Window.vala"
			_tmp9_ = self->priv->episodes_page;
#line 197 "../src/Window.vala"
			audience_episodes_page_search (_tmp9_);
#line 599 "Window.c"
		} else {
			GdkDisplay* _tmp10_;
#line 199 "../src/Window.vala"
			_tmp10_ = gdk_display_get_default ();
#line 199 "../src/Window.vala"
			gdk_display_beep (_tmp10_);
#line 606 "Window.c"
		}
	}
}

static void
audience_window_action_undo (AudienceWindow* self)
{
#line 203 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/Window.vala"
	if (!audience_is_sandboxed ()) {
#line 618 "Window.c"
		AudienceServicesLibraryManager* _tmp0_;
		AudienceServicesLibraryManager* _tmp1_;
#line 208 "../src/Window.vala"
		_tmp0_ = audience_services_library_manager_get_instance ();
#line 208 "../src/Window.vala"
		_tmp1_ = _tmp0_;
#line 208 "../src/Window.vala"
		audience_services_library_manager_undo_delete_item (_tmp1_);
#line 208 "../src/Window.vala"
		_g_object_unref0 (_tmp1_);
#line 629 "Window.c"
	}
}

/** Returns true if the code parameter matches the keycode of the keyval parameter for
    * any keyboard group or level (in order to allow for non-QWERTY keyboards) **/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 215 "../src/Window.vala"
	return self ? g_object_ref (self) : NULL;
#line 640 "Window.c"
}

gboolean
audience_window_match_keycode (AudienceWindow* self,
                               guint keyval,
                               guint code)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkDisplay* _tmp2_;
	GdkKeymapKey* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gboolean _tmp5_;
	gboolean result;
#line 214 "../src/Window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "../src/Window.vala"
	_tmp0_ = gdk_display_get_default ();
#line 215 "../src/Window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 215 "../src/Window.vala"
	display = _tmp1_;
#line 217 "../src/Window.vala"
	_tmp2_ = display;
#line 217 "../src/Window.vala"
	_tmp5_ = gdk_display_map_keyval (_tmp2_, keyval, &_tmp3_, &_tmp4_);
#line 217 "../src/Window.vala"
	keys = (g_free (keys), NULL);
#line 217 "../src/Window.vala"
	keys = _tmp3_;
#line 217 "../src/Window.vala"
	keys_length1 = _tmp4_;
#line 217 "../src/Window.vala"
	_keys_size_ = keys_length1;
#line 217 "../src/Window.vala"
	if (_tmp5_) {
#line 681 "Window.c"
		GdkKeymapKey* _tmp6_;
		gint _tmp6__length1;
#line 218 "../src/Window.vala"
		_tmp6_ = keys;
#line 218 "../src/Window.vala"
		_tmp6__length1 = keys_length1;
#line 688 "Window.c"
		{
			GdkKeymapKey* key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 218 "../src/Window.vala"
			key_collection = _tmp6_;
#line 218 "../src/Window.vala"
			key_collection_length1 = _tmp6__length1;
#line 218 "../src/Window.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 700 "Window.c"
				GdkKeymapKey key = {0};
#line 218 "../src/Window.vala"
				key = key_collection[key_it];
#line 704 "Window.c"
				{
					GdkKeymapKey _tmp7_;
#line 219 "../src/Window.vala"
					_tmp7_ = key;
#line 219 "../src/Window.vala"
					if (code == _tmp7_.keycode) {
#line 220 "../src/Window.vala"
						result = TRUE;
#line 220 "../src/Window.vala"
						keys = (g_free (keys), NULL);
#line 220 "../src/Window.vala"
						_g_object_unref0 (display);
#line 220 "../src/Window.vala"
						return result;
#line 719 "Window.c"
					}
				}
			}
		}
	}
#line 225 "../src/Window.vala"
	result = FALSE;
#line 225 "../src/Window.vala"
	keys = (g_free (keys), NULL);
#line 225 "../src/Window.vala"
	_g_object_unref0 (display);
#line 225 "../src/Window.vala"
	return result;
#line 733 "Window.c"
}

void
audience_window_handle_key_press (AudienceWindow* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state)
{
	AdwNavigationView* _tmp2_;
	AdwNavigationPage* _tmp3_;
	AdwNavigationPage* _tmp4_;
	AudiencePlayerPage* _tmp5_;
#line 228 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/Window.vala"
	if (keyval == GDK_KEY_Escape) {
#line 750 "Window.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 230 "../src/Window.vala"
		g_object_get ((GtkWindow*) self, "fullscreened", &_tmp0_, NULL);
#line 230 "../src/Window.vala"
		_tmp1_ = _tmp0_;
#line 230 "../src/Window.vala"
		if (_tmp1_) {
#line 231 "../src/Window.vala"
			gtk_window_unfullscreen ((GtkWindow*) self);
#line 761 "Window.c"
		} else {
#line 233 "../src/Window.vala"
			gtk_window_destroy ((GtkWindow*) self);
#line 765 "Window.c"
		}
	}
#line 237 "../src/Window.vala"
	_tmp2_ = self->priv->navigation_view;
#line 237 "../src/Window.vala"
	_tmp3_ = adw_navigation_view_get_visible_page (_tmp2_);
#line 237 "../src/Window.vala"
	_tmp4_ = _tmp3_;
#line 237 "../src/Window.vala"
	_tmp5_ = self->priv->player_page;
#line 237 "../src/Window.vala"
	if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, adw_navigation_page_get_type (), AdwNavigationPage)) {
#line 778 "Window.c"
		gboolean _tmp6_ = FALSE;
		gboolean shift_pressed = FALSE;
#line 238 "../src/Window.vala"
		if (audience_window_match_keycode (self, GDK_KEY_space, keycode)) {
#line 238 "../src/Window.vala"
			_tmp6_ = TRUE;
#line 785 "Window.c"
		} else {
#line 238 "../src/Window.vala"
			_tmp6_ = audience_window_match_keycode (self, GDK_KEY_p, keycode);
#line 789 "Window.c"
		}
#line 238 "../src/Window.vala"
		if (_tmp6_) {
#line 793 "Window.c"
			GAction* play_pause_action = NULL;
			GApplication* _tmp7_;
			GAction* _tmp8_;
			GAction* _tmp9_;
			GAction* _tmp10_;
#line 239 "../src/Window.vala"
			_tmp7_ = g_application_get_default ();
#line 239 "../src/Window.vala"
			_tmp8_ = g_action_map_lookup_action ((GActionMap*) _tmp7_, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 239 "../src/Window.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 239 "../src/Window.vala"
			play_pause_action = _tmp9_;
#line 240 "../src/Window.vala"
			_tmp10_ = play_pause_action;
#line 240 "../src/Window.vala"
			g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_simple_action_get_type (), GSimpleAction), "activate", NULL);
#line 238 "../src/Window.vala"
			_g_object_unref0 (play_pause_action);
#line 813 "Window.c"
		} else {
#line 241 "../src/Window.vala"
			if (audience_window_match_keycode (self, GDK_KEY_a, keycode)) {
#line 817 "Window.c"
				AudiencePlaybackManager* _tmp11_;
#line 242 "../src/Window.vala"
				_tmp11_ = audience_playback_manager_get_default ();
#line 242 "../src/Window.vala"
				g_signal_emit_by_name (_tmp11_, "next-audio");
#line 823 "Window.c"
			} else {
#line 243 "../src/Window.vala"
				if (audience_window_match_keycode (self, GDK_KEY_s, keycode)) {
#line 827 "Window.c"
					AudiencePlaybackManager* _tmp12_;
#line 244 "../src/Window.vala"
					_tmp12_ = audience_playback_manager_get_default ();
#line 244 "../src/Window.vala"
					g_signal_emit_by_name (_tmp12_, "next-text");
#line 833 "Window.c"
				}
			}
		}
#line 247 "../src/Window.vala"
		shift_pressed = (state & GDK_SHIFT_MASK) == GDK_SHIFT_MASK;
#line 248 "../src/Window.vala"
		switch (keyval) {
#line 248 "../src/Window.vala"
			case GDK_KEY_Down:
#line 843 "Window.c"
			{
				gint _tmp13_ = 0;
				AudiencePlayerPage* _tmp14_;
#line 250 "../src/Window.vala"
				if (shift_pressed) {
#line 250 "../src/Window.vala"
					_tmp13_ = -5;
#line 851 "Window.c"
				} else {
#line 250 "../src/Window.vala"
					_tmp13_ = -60;
#line 855 "Window.c"
				}
#line 250 "../src/Window.vala"
				_tmp14_ = self->priv->player_page;
#line 250 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp14_, _tmp13_);
#line 251 "../src/Window.vala"
				break;
#line 863 "Window.c"
			}
#line 248 "../src/Window.vala"
			case GDK_KEY_Left:
#line 867 "Window.c"
			{
				gint _tmp15_ = 0;
				AudiencePlayerPage* _tmp16_;
#line 253 "../src/Window.vala"
				if (shift_pressed) {
#line 253 "../src/Window.vala"
					_tmp15_ = -1;
#line 875 "Window.c"
				} else {
#line 253 "../src/Window.vala"
					_tmp15_ = -10;
#line 879 "Window.c"
				}
#line 253 "../src/Window.vala"
				_tmp16_ = self->priv->player_page;
#line 253 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp16_, _tmp15_);
#line 254 "../src/Window.vala"
				break;
#line 887 "Window.c"
			}
#line 248 "../src/Window.vala"
			case GDK_KEY_Right:
#line 891 "Window.c"
			{
				gint _tmp17_ = 0;
				AudiencePlayerPage* _tmp18_;
#line 256 "../src/Window.vala"
				if (shift_pressed) {
#line 256 "../src/Window.vala"
					_tmp17_ = 1;
#line 899 "Window.c"
				} else {
#line 256 "../src/Window.vala"
					_tmp17_ = 10;
#line 903 "Window.c"
				}
#line 256 "../src/Window.vala"
				_tmp18_ = self->priv->player_page;
#line 256 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp18_, _tmp17_);
#line 257 "../src/Window.vala"
				break;
#line 911 "Window.c"
			}
#line 248 "../src/Window.vala"
			case GDK_KEY_Up:
#line 915 "Window.c"
			{
				gint _tmp19_ = 0;
				AudiencePlayerPage* _tmp20_;
#line 259 "../src/Window.vala"
				if (shift_pressed) {
#line 259 "../src/Window.vala"
					_tmp19_ = 5;
#line 923 "Window.c"
				} else {
#line 259 "../src/Window.vala"
					_tmp19_ = 60;
#line 927 "Window.c"
				}
#line 259 "../src/Window.vala"
				_tmp20_ = self->priv->player_page;
#line 259 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp20_, _tmp19_);
#line 260 "../src/Window.vala"
				break;
#line 935 "Window.c"
			}
#line 248 "../src/Window.vala"
			case GDK_KEY_Page_Down:
#line 939 "Window.c"
			{
				AudiencePlayerPage* _tmp21_;
#line 262 "../src/Window.vala"
				_tmp21_ = self->priv->player_page;
#line 262 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp21_, -600);
#line 263 "../src/Window.vala"
				break;
#line 948 "Window.c"
			}
#line 248 "../src/Window.vala"
			case GDK_KEY_Page_Up:
#line 952 "Window.c"
			{
				AudiencePlayerPage* _tmp22_;
#line 265 "../src/Window.vala"
				_tmp22_ = self->priv->player_page;
#line 265 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp22_, 600);
#line 266 "../src/Window.vala"
				break;
#line 961 "Window.c"
			}
			default:
			{
#line 268 "../src/Window.vala"
				break;
#line 967 "Window.c"
			}
		}
	} else {
		AdwNavigationView* _tmp23_;
		AdwNavigationPage* _tmp24_;
		AdwNavigationPage* _tmp25_;
		AudienceWelcomePage* _tmp26_;
#line 270 "../src/Window.vala"
		_tmp23_ = self->priv->navigation_view;
#line 270 "../src/Window.vala"
		_tmp24_ = adw_navigation_view_get_visible_page (_tmp23_);
#line 270 "../src/Window.vala"
		_tmp25_ = _tmp24_;
#line 270 "../src/Window.vala"
		_tmp26_ = self->priv->welcome_page;
#line 270 "../src/Window.vala"
		if (_tmp25_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, adw_navigation_page_get_type (), AdwNavigationPage)) {
#line 985 "Window.c"
			gboolean ctrl_pressed = FALSE;
			gboolean _tmp27_ = FALSE;
#line 271 "../src/Window.vala"
			ctrl_pressed = (state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 272 "../src/Window.vala"
			if (audience_window_match_keycode (self, GDK_KEY_p, keycode)) {
#line 272 "../src/Window.vala"
				_tmp27_ = TRUE;
#line 994 "Window.c"
			} else {
#line 272 "../src/Window.vala"
				_tmp27_ = audience_window_match_keycode (self, GDK_KEY_space, keycode);
#line 998 "Window.c"
			}
#line 272 "../src/Window.vala"
			if (_tmp27_) {
#line 273 "../src/Window.vala"
				audience_window_resume_last_videos (self);
#line 1004 "Window.c"
			} else {
				gboolean _tmp28_ = FALSE;
#line 274 "../src/Window.vala"
				if (ctrl_pressed) {
#line 274 "../src/Window.vala"
					_tmp28_ = audience_window_match_keycode (self, GDK_KEY_b, keycode);
#line 1011 "Window.c"
				} else {
#line 274 "../src/Window.vala"
					_tmp28_ = FALSE;
#line 1015 "Window.c"
				}
#line 274 "../src/Window.vala"
				if (_tmp28_) {
#line 275 "../src/Window.vala"
					audience_window_show_library (self);
#line 1021 "Window.c"
				}
			}
		}
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 280 "../src/Window.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 280 "../src/Window.vala"
	return _data2_;
#line 1035 "Window.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 280 "../src/Window.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1045 "Window.c"
		AudienceWindow* self;
#line 280 "../src/Window.vala"
		self = _data2_->self;
#line 280 "../src/Window.vala"
		_data2_->videos = (_vala_array_free (_data2_->videos, _data2_->videos_length1, (GDestroyNotify) g_free), NULL);
#line 280 "../src/Window.vala"
		_g_object_unref0 (self);
#line 280 "../src/Window.vala"
		g_slice_free (Block2Data, _data2_);
#line 1055 "Window.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 290 "../src/Window.vala"
	if ((*length) == (*size)) {
#line 290 "../src/Window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 290 "../src/Window.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1071 "Window.c"
	}
#line 290 "../src/Window.vala"
	(*array)[(*length)++] = value;
#line 290 "../src/Window.vala"
	(*array)[*length] = NULL;
#line 1077 "Window.c"
}

static void
_____lambda27_ (Block2Data* _data2_,
                GFile* file_ret)
{
	AudienceWindow* self;
	gchar* _tmp0_;
#line 289 "../src/Window.vala"
	self = _data2_->self;
#line 289 "../src/Window.vala"
	g_return_if_fail (file_ret != NULL);
#line 290 "../src/Window.vala"
	_tmp0_ = g_file_get_uri (file_ret);
#line 290 "../src/Window.vala"
	_vala_array_add1 (&_data2_->videos, &_data2_->videos_length1, &_data2_->_videos_size_, _tmp0_);
#line 1094 "Window.c"
}

static void
______lambda27__audience_func_over_dir (GFile* file_under_dir,
                                        gpointer self)
{
#line 289 "../src/Window.vala"
	_____lambda27_ (self, file_under_dir);
#line 1103 "Window.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 293 "../src/Window.vala"
	if ((*length) == (*size)) {
#line 293 "../src/Window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 293 "../src/Window.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1118 "Window.c"
	}
#line 293 "../src/Window.vala"
	(*array)[(*length)++] = value;
#line 293 "../src/Window.vala"
	(*array)[*length] = NULL;
#line 1124 "Window.c"
}

void
audience_window_open_files (AudienceWindow* self,
                            GFile** files,
                            gint files_length1,
                            gboolean clear_playlist_items,
                            gboolean force_play)
{
	Block2Data* _data2_;
	gchar** _tmp1_;
	AudiencePlaybackManager* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gboolean _tmp9_ = FALSE;
#line 280 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 280 "../src/Window.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 280 "../src/Window.vala"
	_data2_->_ref_count_ = 1;
#line 280 "../src/Window.vala"
	_data2_->self = g_object_ref (self);
#line 281 "../src/Window.vala"
	if (clear_playlist_items) {
#line 1150 "Window.c"
		AudiencePlaybackManager* _tmp0_;
#line 282 "../src/Window.vala"
		_tmp0_ = audience_playback_manager_get_default ();
#line 282 "../src/Window.vala"
		audience_playback_manager_clear_playlist (_tmp0_, FALSE);
#line 1156 "Window.c"
	}
#line 285 "../src/Window.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 285 "../src/Window.vala"
	_data2_->videos = _tmp1_;
#line 285 "../src/Window.vala"
	_data2_->videos_length1 = 0;
#line 285 "../src/Window.vala"
	_data2_->_videos_size_ = _data2_->videos_length1;
#line 1166 "Window.c"
	{
		GFile** file_collection = NULL;
		gint file_collection_length1 = 0;
		gint _file_collection_size_ = 0;
		gint file_it = 0;
#line 287 "../src/Window.vala"
		file_collection = files;
#line 287 "../src/Window.vala"
		file_collection_length1 = files_length1;
#line 287 "../src/Window.vala"
		for (file_it = 0; file_it < file_collection_length1; file_it = file_it + 1) {
#line 1178 "Window.c"
			GFile* _tmp2_;
			GFile* file = NULL;
#line 287 "../src/Window.vala"
			_tmp2_ = _g_object_ref0 (file_collection[file_it]);
#line 287 "../src/Window.vala"
			file = _tmp2_;
#line 1185 "Window.c"
			{
				GFile* _tmp3_;
#line 288 "../src/Window.vala"
				_tmp3_ = file;
#line 288 "../src/Window.vala"
				if (g_file_query_file_type (_tmp3_, 0, NULL) == G_FILE_TYPE_DIRECTORY) {
#line 1192 "Window.c"
					GFile* _tmp4_;
#line 289 "../src/Window.vala"
					_tmp4_ = file;
#line 289 "../src/Window.vala"
					audience_recurse_over_dir (_tmp4_, ______lambda27__audience_func_over_dir, _data2_);
#line 1198 "Window.c"
				} else {
					GFile* _tmp5_;
					gchar* _tmp6_;
#line 293 "../src/Window.vala"
					_tmp5_ = file;
#line 293 "../src/Window.vala"
					_tmp6_ = g_file_get_uri (_tmp5_);
#line 293 "../src/Window.vala"
					_vala_array_add2 (&_data2_->videos, &_data2_->videos_length1, &_data2_->_videos_size_, _tmp6_);
#line 1208 "Window.c"
				}
#line 287 "../src/Window.vala"
				_g_object_unref0 (file);
#line 1212 "Window.c"
			}
		}
	}
#line 297 "../src/Window.vala"
	_tmp7_ = audience_playback_manager_get_default ();
#line 297 "../src/Window.vala"
	_tmp8_ = _data2_->videos;
#line 297 "../src/Window.vala"
	_tmp8__length1 = _data2_->videos_length1;
#line 297 "../src/Window.vala"
	audience_playback_manager_append_to_playlist (_tmp7_, _tmp8_, (gint) _tmp8__length1);
#line 299 "../src/Window.vala"
	if (force_play) {
#line 1226 "Window.c"
		gchar** _tmp10_;
		gint _tmp10__length1;
#line 299 "../src/Window.vala"
		_tmp10_ = _data2_->videos;
#line 299 "../src/Window.vala"
		_tmp10__length1 = _data2_->videos_length1;
#line 299 "../src/Window.vala"
		_tmp9_ = _tmp10__length1 > 0;
#line 1235 "Window.c"
	} else {
#line 299 "../src/Window.vala"
		_tmp9_ = FALSE;
#line 1239 "Window.c"
	}
#line 299 "../src/Window.vala"
	if (_tmp9_) {
#line 1243 "Window.c"
		gchar* videofile = NULL;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		AudienceWindowNavigationPage page = 0;
		AudienceLibraryPage* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 300 "../src/Window.vala"
		_tmp11_ = _data2_->videos;
#line 300 "../src/Window.vala"
		_tmp11__length1 = _data2_->videos_length1;
#line 300 "../src/Window.vala"
		_tmp12_ = _tmp11_[0];
#line 300 "../src/Window.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 300 "../src/Window.vala"
		videofile = _tmp13_;
#line 301 "../src/Window.vala"
		_tmp14_ = self->priv->library_page;
#line 301 "../src/Window.vala"
		_tmp15_ = videofile;
#line 301 "../src/Window.vala"
		page = audience_library_page_prepare_to_play (_tmp14_, _tmp15_);
#line 302 "../src/Window.vala"
		_tmp16_ = videofile;
#line 302 "../src/Window.vala"
		audience_window_play_file (self, _tmp16_, page, TRUE);
#line 299 "../src/Window.vala"
		_g_free0 (videofile);
#line 1275 "Window.c"
	}
#line 280 "../src/Window.vala"
	block2_data_unref (_data2_);
#line 280 "../src/Window.vala"
	_data2_ = NULL;
#line 1281 "Window.c"
}

void
audience_window_resume_last_videos (AudienceWindow* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 306 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Window.vala"
	_tmp0_ = audience_settings;
#line 307 "../src/Window.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "current-video");
#line 307 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 307 "../src/Window.vala"
	_tmp3_ = g_strcmp0 (_tmp2_, "") != 0;
#line 307 "../src/Window.vala"
	_g_free0 (_tmp2_);
#line 307 "../src/Window.vala"
	if (_tmp3_) {
#line 1305 "Window.c"
		GSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 308 "../src/Window.vala"
		_tmp4_ = audience_settings;
#line 308 "../src/Window.vala"
		_tmp5_ = g_settings_get_string (_tmp4_, "current-video");
#line 308 "../src/Window.vala"
		_tmp6_ = _tmp5_;
#line 308 "../src/Window.vala"
		audience_window_play_file (self, _tmp6_, AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME, FALSE);
#line 308 "../src/Window.vala"
		_g_free0 (_tmp6_);
#line 1319 "Window.c"
	} else {
#line 310 "../src/Window.vala"
		audience_window_action_open_file (self);
#line 1323 "Window.c"
	}
}

void
audience_window_show_library (AudienceWindow* self)
{
	AdwNavigationView* _tmp0_;
	AudienceLibraryPage* _tmp1_;
#line 314 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 315 "../src/Window.vala"
	_tmp0_ = self->priv->navigation_view;
#line 315 "../src/Window.vala"
	_tmp1_ = self->priv->library_page;
#line 315 "../src/Window.vala"
	adw_navigation_view_push (_tmp0_, (AdwNavigationPage*) _tmp1_);
#line 1340 "Window.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 318 "../src/Window.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 318 "../src/Window.vala"
	return _data3_;
#line 1350 "Window.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 318 "../src/Window.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1360 "Window.c"
		AudienceWindow* self;
#line 318 "../src/Window.vala"
		self = _data3_->self;
#line 318 "../src/Window.vala"
		_g_object_unref0 (_data3_->file);
#line 318 "../src/Window.vala"
		_g_object_unref0 (self);
#line 318 "../src/Window.vala"
		g_slice_free (Block3Data, _data3_);
#line 1370 "Window.c"
	}
}

static void
_vala_array_add3 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 350 "../src/Window.vala"
	if ((*length) == (*size)) {
#line 350 "../src/Window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 350 "../src/Window.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 1386 "Window.c"
	}
#line 350 "../src/Window.vala"
	(*array)[(*length)++] = value;
#line 350 "../src/Window.vala"
	(*array)[*length] = NULL;
#line 1392 "Window.c"
}

static void
__lambda26_ (Block3Data* _data3_,
             gint response)
{
	AudienceWindow* self;
#line 344 "../src/Window.vala"
	self = _data3_->self;
#line 345 "../src/Window.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1404 "Window.c"
		GFile** files = NULL;
		GFile** _tmp0_;
		gint files_length1;
		gint _files_size_;
		GListModel* files_list = NULL;
		GListModel* _tmp1_;
		GFile** _tmp7_;
		gint _tmp7__length1;
		GSettings* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 346 "../src/Window.vala"
		_tmp0_ = g_new0 (GFile*, 0 + 1);
#line 346 "../src/Window.vala"
		files = _tmp0_;
#line 346 "../src/Window.vala"
		files_length1 = 0;
#line 346 "../src/Window.vala"
		_files_size_ = files_length1;
#line 348 "../src/Window.vala"
		_tmp1_ = gtk_file_chooser_get_files ((GtkFileChooser*) _data3_->file);
#line 348 "../src/Window.vala"
		files_list = _tmp1_;
#line 1430 "Window.c"
		{
			gint i = 0;
#line 349 "../src/Window.vala"
			i = 0;
#line 1435 "Window.c"
			{
				gboolean _tmp2_ = FALSE;
#line 349 "../src/Window.vala"
				_tmp2_ = TRUE;
#line 349 "../src/Window.vala"
				while (TRUE) {
#line 1442 "Window.c"
					GListModel* _tmp4_;
					GListModel* _tmp5_;
					GObject* _tmp6_;
#line 349 "../src/Window.vala"
					if (!_tmp2_) {
#line 1448 "Window.c"
						gint _tmp3_;
#line 349 "../src/Window.vala"
						_tmp3_ = i;
#line 349 "../src/Window.vala"
						i = _tmp3_ + 1;
#line 1454 "Window.c"
					}
#line 349 "../src/Window.vala"
					_tmp2_ = FALSE;
#line 349 "../src/Window.vala"
					_tmp4_ = files_list;
#line 349 "../src/Window.vala"
					if (!(((guint) i) < g_list_model_get_n_items (_tmp4_))) {
#line 349 "../src/Window.vala"
						break;
#line 1464 "Window.c"
					}
#line 350 "../src/Window.vala"
					_tmp5_ = files_list;
#line 350 "../src/Window.vala"
					_tmp6_ = g_list_model_get_item (_tmp5_, (guint) i);
#line 350 "../src/Window.vala"
					_vala_array_add3 (&files, &files_length1, &_files_size_, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_file_get_type (), GFile));
#line 1472 "Window.c"
				}
			}
		}
#line 353 "../src/Window.vala"
		_tmp7_ = files;
#line 353 "../src/Window.vala"
		_tmp7__length1 = files_length1;
#line 353 "../src/Window.vala"
		audience_window_open_files (self, _tmp7_, (gint) _tmp7__length1, _data3_->clear_playlist, _data3_->force_play);
#line 354 "../src/Window.vala"
		_tmp8_ = audience_settings;
#line 354 "../src/Window.vala"
		_tmp9_ = gtk_file_chooser_get_current_folder ((GtkFileChooser*) _data3_->file);
#line 354 "../src/Window.vala"
		_tmp10_ = _tmp9_;
#line 354 "../src/Window.vala"
		_tmp11_ = g_file_get_path (_tmp10_);
#line 354 "../src/Window.vala"
		_tmp12_ = _tmp11_;
#line 354 "../src/Window.vala"
		g_settings_set_string (_tmp8_, "last-folder", _tmp12_);
#line 354 "../src/Window.vala"
		_g_free0 (_tmp12_);
#line 354 "../src/Window.vala"
		_g_object_unref0 (_tmp10_);
#line 345 "../src/Window.vala"
		_g_object_unref0 (files_list);
#line 345 "../src/Window.vala"
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1502 "Window.c"
	}
#line 357 "../src/Window.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _data3_->file);
#line 1506 "Window.c"
}

static void
___lambda26__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 344 "../src/Window.vala"
	__lambda26_ (self, response_id);
#line 1516 "Window.c"
}

void
audience_window_run_open_file (AudienceWindow* self,
                               gboolean clear_playlist,
                               gboolean force_play)
{
	Block3Data* _data3_;
	GtkFileFilter* all_files_filter = NULL;
	GtkFileFilter* _tmp0_;
	GtkFileFilter* video_filter = NULL;
	GtkFileFilter* _tmp1_;
	GtkFileChooserNative* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 318 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/Window.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 318 "../src/Window.vala"
	_data3_->_ref_count_ = 1;
#line 318 "../src/Window.vala"
	_data3_->self = g_object_ref (self);
#line 318 "../src/Window.vala"
	_data3_->clear_playlist = clear_playlist;
#line 318 "../src/Window.vala"
	_data3_->force_play = force_play;
#line 319 "../src/Window.vala"
	_tmp0_ = gtk_file_filter_new ();
#line 319 "../src/Window.vala"
	all_files_filter = _tmp0_;
#line 320 "../src/Window.vala"
	gtk_file_filter_set_name (all_files_filter, _ ("All files"));
#line 321 "../src/Window.vala"
	gtk_file_filter_add_pattern (all_files_filter, "*");
#line 323 "../src/Window.vala"
	_tmp1_ = gtk_file_filter_new ();
#line 323 "../src/Window.vala"
	video_filter = _tmp1_;
#line 324 "../src/Window.vala"
	gtk_file_filter_set_name (video_filter, _ ("Video files"));
#line 325 "../src/Window.vala"
	gtk_file_filter_add_mime_type (video_filter, "video/*");
#line 327 "../src/Window.vala"
	_tmp2_ = gtk_file_chooser_native_new (_ ("Open"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("_Open"), _ ("_Cancel"));
#line 327 "../src/Window.vala"
	_data3_->file = _tmp2_;
#line 334 "../src/Window.vala"
	gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _data3_->file, TRUE);
#line 335 "../src/Window.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _data3_->file, video_filter);
#line 336 "../src/Window.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _data3_->file, all_files_filter);
#line 1569 "Window.c"
	{
		GSettings* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 339 "../src/Window.vala"
		_tmp3_ = audience_settings;
#line 339 "../src/Window.vala"
		_tmp4_ = g_settings_get_string (_tmp3_, "last-folder");
#line 339 "../src/Window.vala"
		_tmp5_ = _tmp4_;
#line 339 "../src/Window.vala"
		_tmp6_ = g_file_new_for_path (_tmp5_);
#line 339 "../src/Window.vala"
		_tmp7_ = _tmp6_;
#line 339 "../src/Window.vala"
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _data3_->file, _tmp7_, &_inner_error0_);
#line 339 "../src/Window.vala"
		_g_object_unref0 (_tmp7_);
#line 339 "../src/Window.vala"
		_g_free0 (_tmp5_);
#line 339 "../src/Window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "Window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 338 "../src/Window.vala"
		e = _inner_error0_;
#line 338 "../src/Window.vala"
		_inner_error0_ = NULL;
#line 341 "../src/Window.vala"
		_tmp8_ = e;
#line 341 "../src/Window.vala"
		_tmp9_ = _tmp8_->message;
#line 341 "../src/Window.vala"
		g_warning ("Window.vala:341: Failed to set last folder as current folder: %s", _tmp9_);
#line 338 "../src/Window.vala"
		_g_error_free0 (e);
#line 1616 "Window.c"
	}
	__finally0:
#line 338 "../src/Window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 338 "../src/Window.vala"
		_g_object_unref0 (video_filter);
#line 338 "../src/Window.vala"
		_g_object_unref0 (all_files_filter);
#line 338 "../src/Window.vala"
		block3_data_unref (_data3_);
#line 338 "../src/Window.vala"
		_data3_ = NULL;
#line 338 "../src/Window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 338 "../src/Window.vala"
		g_clear_error (&_inner_error0_);
#line 338 "../src/Window.vala"
		return;
#line 1635 "Window.c"
	}
#line 344 "../src/Window.vala"
	g_signal_connect_data ((GtkNativeDialog*) _data3_->file, "response", (GCallback) ___lambda26__gtk_native_dialog_response, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 360 "../src/Window.vala"
	gtk_native_dialog_show ((GtkNativeDialog*) _data3_->file);
#line 318 "../src/Window.vala"
	_g_object_unref0 (video_filter);
#line 318 "../src/Window.vala"
	_g_object_unref0 (all_files_filter);
#line 318 "../src/Window.vala"
	block3_data_unref (_data3_);
#line 318 "../src/Window.vala"
	_data3_ = NULL;
#line 1649 "Window.c"
}

static void
audience_window_on_player_ended (AudienceWindow* self)
{
	AdwNavigationView* _tmp0_;
#line 363 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 364 "../src/Window.vala"
	_tmp0_ = self->priv->navigation_view;
#line 364 "../src/Window.vala"
	adw_navigation_view_pop (_tmp0_);
#line 1662 "Window.c"
}

void
audience_window_play_file (AudienceWindow* self,
                           const gchar* uri,
                           AudienceWindowNavigationPage origin,
                           gboolean from_beginning)
{
	AdwNavigationView* _tmp0_;
	AudiencePlayerPage* _tmp1_;
	AudiencePlaybackManager* _tmp2_;
#line 367 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/Window.vala"
	g_return_if_fail (uri != NULL);
#line 368 "../src/Window.vala"
	_tmp0_ = self->priv->navigation_view;
#line 368 "../src/Window.vala"
	_tmp1_ = self->priv->player_page;
#line 368 "../src/Window.vala"
	adw_navigation_view_push (_tmp0_, (AdwNavigationPage*) _tmp1_);
#line 370 "../src/Window.vala"
	_tmp2_ = audience_playback_manager_get_default ();
#line 370 "../src/Window.vala"
	audience_playback_manager_play_file (_tmp2_, uri, from_beginning);
#line 1688 "Window.c"
}

static GVariant*
_variant_new3 (gboolean value)
{
#line 382 "../src/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1696 "Window.c"
}

static GVariant*
_variant_new4 (gboolean value)
{
#line 384 "../src/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1704 "Window.c"
}

static void
audience_window_update_navigation (AudienceWindow* self)
{
	gint64 position = 0LL;
	AudiencePlaybackManager* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GAction* play_pause_action = NULL;
	GApplication* _tmp4_;
	GAction* _tmp5_;
	GAction* _tmp6_;
	AdwNavigationView* _tmp7_;
	AdwNavigationPage* _tmp8_;
	AdwNavigationPage* _tmp9_;
	AudiencePlayerPage* _tmp10_;
#line 373 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 374 "../src/Window.vala"
	_tmp0_ = audience_playback_manager_get_default ();
#line 374 "../src/Window.vala"
	_tmp1_ = audience_playback_manager_get_position (_tmp0_);
#line 374 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 374 "../src/Window.vala"
	position = _tmp2_;
#line 375 "../src/Window.vala"
	if (position > ((gint64) 0)) {
#line 1734 "Window.c"
		GSettings* _tmp3_;
#line 376 "../src/Window.vala"
		_tmp3_ = audience_settings;
#line 376 "../src/Window.vala"
		g_settings_set_int64 (_tmp3_, "last-stopped", position);
#line 1740 "Window.c"
	}
#line 379 "../src/Window.vala"
	_tmp4_ = g_application_get_default ();
#line 379 "../src/Window.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 379 "../src/Window.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 379 "../src/Window.vala"
	play_pause_action = _tmp6_;
#line 381 "../src/Window.vala"
	_tmp7_ = self->priv->navigation_view;
#line 381 "../src/Window.vala"
	_tmp8_ = adw_navigation_view_get_visible_page (_tmp7_);
#line 381 "../src/Window.vala"
	_tmp9_ = _tmp8_;
#line 381 "../src/Window.vala"
	_tmp10_ = self->priv->player_page;
#line 381 "../src/Window.vala"
	if (_tmp9_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, adw_navigation_page_get_type (), AdwNavigationPage)) {
#line 1760 "Window.c"
		GAction* _tmp11_;
		GVariant* _tmp12_;
#line 382 "../src/Window.vala"
		_tmp11_ = play_pause_action;
#line 382 "../src/Window.vala"
		_tmp12_ = _variant_new3 (TRUE);
#line 382 "../src/Window.vala"
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_simple_action_get_type (), GSimpleAction), _tmp12_);
#line 382 "../src/Window.vala"
		_g_variant_unref0 (_tmp12_);
#line 1771 "Window.c"
	} else {
		GAction* _tmp13_;
		GVariant* _tmp14_;
#line 384 "../src/Window.vala"
		_tmp13_ = play_pause_action;
#line 384 "../src/Window.vala"
		_tmp14_ = _variant_new4 (FALSE);
#line 384 "../src/Window.vala"
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_simple_action_get_type (), GSimpleAction), _tmp14_);
#line 384 "../src/Window.vala"
		_g_variant_unref0 (_tmp14_);
#line 1783 "Window.c"
	}
#line 373 "../src/Window.vala"
	_g_object_unref0 (play_pause_action);
#line 1787 "Window.c"
}

AudienceWindow*
audience_window_construct (GType object_type)
{
	AudienceWindow * self = NULL;
#line 23 "../src/Window.vala"
	self = (AudienceWindow*) g_object_new (object_type, NULL);
#line 23 "../src/Window.vala"
	return self;
#line 1798 "Window.c"
}

AudienceWindow*
audience_window_new (void)
{
#line 23 "../src/Window.vala"
	return audience_window_construct (AUDIENCE_TYPE_WINDOW);
#line 1806 "Window.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 64 "../src/Window.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 64 "../src/Window.vala"
	return _data4_;
#line 1816 "Window.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 64 "../src/Window.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1826 "Window.c"
		AudienceWindow* self;
#line 64 "../src/Window.vala"
		self = _data4_->self;
#line 64 "../src/Window.vala"
		_g_object_unref0 (_data4_->playback_manager);
#line 64 "../src/Window.vala"
		_g_object_unref0 (self);
#line 64 "../src/Window.vala"
		g_slice_free (Block4Data, _data4_);
#line 1836 "Window.c"
	}
}

static void
_audience_window_action_undo_granite_toast_default_action (GraniteToast* _sender,
                                                           gpointer self)
{
#line 111 "../src/Window.vala"
	audience_window_action_undo ((AudienceWindow*) self);
#line 1846 "Window.c"
}

static void
_audience_window___lambda72_ (AudienceWindow* self,
                              AudienceObjectsMediaItem* item)
{
	GraniteToast* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GraniteToast* _tmp9_;
#line 102 "../src/Window.vala"
	g_return_if_fail (item != NULL);
#line 103 "../src/Window.vala"
	_tmp0_ = self->priv->app_notification;
#line 103 "../src/Window.vala"
	_tmp1_ = audience_objects_media_item_get_title (item);
#line 103 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 103 "../src/Window.vala"
	_tmp3_ = g_strdup_printf (_ ("Video '%s' Removed."), _tmp2_);
#line 103 "../src/Window.vala"
	_tmp4_ = _tmp3_;
#line 103 "../src/Window.vala"
	granite_toast_set_title (_tmp0_, _tmp4_);
#line 103 "../src/Window.vala"
	_g_free0 (_tmp4_);
#line 108 "../src/Window.vala"
	if (!audience_is_sandboxed ()) {
#line 1877 "Window.c"
		GraniteToast* _tmp5_;
		GraniteToast* _tmp6_;
		guint _tmp7_;
		GraniteToast* _tmp8_;
#line 109 "../src/Window.vala"
		_tmp5_ = self->priv->app_notification;
#line 109 "../src/Window.vala"
		granite_toast_set_default_action (_tmp5_, _ ("Restore"));
#line 111 "../src/Window.vala"
		_tmp6_ = self->priv->app_notification;
#line 111 "../src/Window.vala"
		g_signal_parse_name ("default-action", GRANITE_TYPE_TOAST, &_tmp7_, NULL, FALSE);
#line 111 "../src/Window.vala"
		g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _audience_window_action_undo_granite_toast_default_action, self);
#line 112 "../src/Window.vala"
		_tmp8_ = self->priv->app_notification;
#line 112 "../src/Window.vala"
		g_signal_connect_object (_tmp8_, "default-action", (GCallback) _audience_window_action_undo_granite_toast_default_action, self, 0);
#line 1896 "Window.c"
	}
#line 115 "../src/Window.vala"
	_tmp9_ = self->priv->app_notification;
#line 115 "../src/Window.vala"
	granite_toast_send_notification (_tmp9_);
#line 1902 "Window.c"
}

static void
__audience_window___lambda72__audience_services_library_manager_media_item_trashed (AudienceServicesLibraryManager* _sender,
                                                                                    AudienceObjectsMediaItem* item,
                                                                                    gpointer self)
{
#line 102 "../src/Window.vala"
	_audience_window___lambda72_ ((AudienceWindow*) self, item);
#line 1912 "Window.c"
}

static void
_audience_window___lambda73_ (AudienceWindow* self,
                              AudienceObjectsMediaItem* item,
                              gboolean setup_only)
{
	AudienceEpisodesPage* _tmp0_;
#line 118 "../src/Window.vala"
	g_return_if_fail (item != NULL);
#line 119 "../src/Window.vala"
	_tmp0_ = self->priv->episodes_page;
#line 119 "../src/Window.vala"
	audience_episodes_page_set_show (_tmp0_, item);
#line 120 "../src/Window.vala"
	if (!setup_only) {
#line 1929 "Window.c"
		AdwNavigationView* _tmp1_;
		AudienceEpisodesPage* _tmp2_;
#line 121 "../src/Window.vala"
		_tmp1_ = self->priv->navigation_view;
#line 121 "../src/Window.vala"
		_tmp2_ = self->priv->episodes_page;
#line 121 "../src/Window.vala"
		adw_navigation_view_push (_tmp1_, (AdwNavigationPage*) _tmp2_);
#line 1938 "Window.c"
	}
}

static void
__audience_window___lambda73__audience_library_page_show_episodes (AudienceLibraryPage* _sender,
                                                                   AudienceObjectsMediaItem* item,
                                                                   gboolean setup_only,
                                                                   gpointer self)
{
#line 118 "../src/Window.vala"
	_audience_window___lambda73_ ((AudienceWindow*) self, item, setup_only);
#line 1950 "Window.c"
}

static void
_audience_window___lambda74_ (AudienceWindow* self)
{
#line 126 "../src/Window.vala"
	audience_window_update_navigation (self);
#line 1958 "Window.c"
}

static void
__audience_window___lambda74__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 125 "../src/Window.vala"
	_audience_window___lambda74_ ((AudienceWindow*) self);
#line 1968 "Window.c"
}

static void
_audience_window___lambda75_ (Block4Data* _data4_,
                              guint pos,
                              guint removed,
                              guint added)
{
	AudienceWindow* self;
	AudiencePlaybackManager* _tmp0_;
	GtkStringList* _tmp1_;
	GtkStringList* _tmp2_;
	GraniteToast* _tmp3_;
#line 131 "../src/Window.vala"
	self = _data4_->self;
#line 132 "../src/Window.vala"
	_tmp0_ = _data4_->playback_manager;
#line 132 "../src/Window.vala"
	_tmp1_ = audience_playback_manager_get_play_queue (_tmp0_);
#line 132 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 132 "../src/Window.vala"
	if (g_list_model_get_n_items ((GListModel*) _tmp2_) == ((guint) 1)) {
#line 133 "../src/Window.vala"
		return;
#line 1994 "Window.c"
	}
#line 136 "../src/Window.vala"
	_tmp3_ = self->priv->app_notification;
#line 136 "../src/Window.vala"
	granite_toast_set_default_action (_tmp3_, NULL);
#line 138 "../src/Window.vala"
	if (added == ((guint) 1)) {
#line 2002 "Window.c"
		gchar* title = NULL;
		AudiencePlaybackManager* _tmp4_;
		GtkStringList* _tmp5_;
		GtkStringList* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		GraniteToast* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GraniteToast* _tmp13_;
#line 139 "../src/Window.vala"
		_tmp4_ = _data4_->playback_manager;
#line 139 "../src/Window.vala"
		_tmp5_ = audience_playback_manager_get_play_queue (_tmp4_);
#line 139 "../src/Window.vala"
		_tmp6_ = _tmp5_;
#line 139 "../src/Window.vala"
		_tmp7_ = gtk_string_list_get_string (_tmp6_, pos);
#line 139 "../src/Window.vala"
		_tmp8_ = audience_get_title (_tmp7_);
#line 139 "../src/Window.vala"
		title = _tmp8_;
#line 140 "../src/Window.vala"
		_tmp9_ = self->priv->app_notification;
#line 140 "../src/Window.vala"
		_tmp10_ = title;
#line 140 "../src/Window.vala"
		_tmp11_ = g_strdup_printf (_ ("“%s” added to playlist"), _tmp10_);
#line 140 "../src/Window.vala"
		_tmp12_ = _tmp11_;
#line 140 "../src/Window.vala"
		granite_toast_set_title (_tmp9_, _tmp12_);
#line 140 "../src/Window.vala"
		_g_free0 (_tmp12_);
#line 141 "../src/Window.vala"
		_tmp13_ = self->priv->app_notification;
#line 141 "../src/Window.vala"
		granite_toast_send_notification (_tmp13_);
#line 138 "../src/Window.vala"
		_g_free0 (title);
#line 2044 "Window.c"
	} else {
#line 142 "../src/Window.vala"
		if (added > ((guint) 1)) {
#line 2048 "Window.c"
			GraniteToast* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			GraniteToast* _tmp17_;
#line 143 "../src/Window.vala"
			_tmp14_ = self->priv->app_notification;
#line 143 "../src/Window.vala"
			_tmp15_ = g_strdup_printf (ngettext ("%u item added to playlist", "%u items added to playlist", (gulong) added), added);
#line 143 "../src/Window.vala"
			_tmp16_ = _tmp15_;
#line 143 "../src/Window.vala"
			granite_toast_set_title (_tmp14_, _tmp16_);
#line 143 "../src/Window.vala"
			_g_free0 (_tmp16_);
#line 144 "../src/Window.vala"
			_tmp17_ = self->priv->app_notification;
#line 144 "../src/Window.vala"
			granite_toast_send_notification (_tmp17_);
#line 2067 "Window.c"
		}
	}
}

static void
__audience_window___lambda75__g_list_model_items_changed (GListModel* _sender,
                                                          guint position,
                                                          guint removed,
                                                          guint added,
                                                          gpointer self)
{
#line 131 "../src/Window.vala"
	_audience_window___lambda75_ (self, position, removed, added);
#line 2081 "Window.c"
}

static void
_audience_window_on_player_ended_audience_playback_manager_ended (AudiencePlaybackManager* _sender,
                                                                  gpointer self)
{
#line 148 "../src/Window.vala"
	audience_window_on_player_ended ((AudienceWindow*) self);
#line 2090 "Window.c"
}

static void
_audience_window_handle_key_press_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self)
{
#line 152 "../src/Window.vala"
	audience_window_handle_key_press ((AudienceWindow*) self, keyval, keycode, state);
#line 2102 "Window.c"
}

static void
_vala_array_add4 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 164 "../src/Window.vala"
	if ((*length) == (*size)) {
#line 164 "../src/Window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 164 "../src/Window.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 2117 "Window.c"
	}
#line 164 "../src/Window.vala"
	(*array)[(*length)++] = value;
#line 164 "../src/Window.vala"
	(*array)[*length] = NULL;
#line 2123 "Window.c"
}

static gboolean
_audience_window___lambda76_ (AudienceWindow* self,
                              GValue* val)
{
	GFile** files = NULL;
	gint files_length1 = 0;
	gint _files_size_ = 0;
	GSList* file_list = NULL;
	void* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
	GFile** _tmp5_;
	gint _tmp5__length1;
	gboolean result;
#line 156 "../src/Window.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 157 "../src/Window.vala"
	if (G_VALUE_TYPE (val) != gdk_file_list_get_type ()) {
#line 158 "../src/Window.vala"
		result = FALSE;
#line 158 "../src/Window.vala"
		return result;
#line 2148 "Window.c"
	}
#line 162 "../src/Window.vala"
	_tmp0_ = g_value_get_boxed (val);
#line 162 "../src/Window.vala"
	_tmp1_ = gdk_file_list_get_files ((GdkFileList*) _tmp0_);
#line 162 "../src/Window.vala"
	file_list = _tmp1_;
#line 163 "../src/Window.vala"
	_tmp2_ = file_list;
#line 2158 "Window.c"
	{
		GSList* file_collection = NULL;
		GSList* file_it = NULL;
#line 163 "../src/Window.vala"
		file_collection = _tmp2_;
#line 163 "../src/Window.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 2166 "Window.c"
			GFile* file = NULL;
#line 163 "../src/Window.vala"
			file = (GFile*) file_it->data;
#line 2170 "Window.c"
			{
				GFile* _tmp3_;
				GFile* _tmp4_;
#line 164 "../src/Window.vala"
				_tmp3_ = file;
#line 164 "../src/Window.vala"
				_tmp4_ = _g_object_ref0 (_tmp3_);
#line 164 "../src/Window.vala"
				_vala_array_add4 (&files, &files_length1, &_files_size_, _tmp4_);
#line 2180 "Window.c"
			}
		}
	}
#line 167 "../src/Window.vala"
	_tmp5_ = files;
#line 167 "../src/Window.vala"
	_tmp5__length1 = files_length1;
#line 167 "../src/Window.vala"
	audience_window_open_files (self, _tmp5_, (gint) _tmp5__length1, FALSE, TRUE);
#line 169 "../src/Window.vala"
	result = TRUE;
#line 169 "../src/Window.vala"
	(file_list == NULL) ? NULL : (file_list = (g_slist_free (file_list), NULL));
#line 169 "../src/Window.vala"
	files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 169 "../src/Window.vala"
	return result;
#line 2198 "Window.c"
}

static gboolean
__audience_window___lambda76__gtk_drop_target_drop (GtkDropTarget* _sender,
                                                    GValue* value,
                                                    gdouble x,
                                                    gdouble y,
                                                    gpointer self)
{
	gboolean result;
	result = _audience_window___lambda76_ ((AudienceWindow*) self, value);
#line 156 "../src/Window.vala"
	return result;
#line 2212 "Window.c"
}

static GObject *
audience_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AudienceWindow * self;
	Block4Data* _data4_;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	AudienceLibraryPage* _tmp21_;
	AudienceWelcomePage* _tmp22_;
	AudiencePlayerPage* _tmp23_;
	AudienceEpisodesPage* _tmp24_;
	AdwNavigationView* _tmp25_;
	AdwNavigationView* _tmp26_;
	AudienceWelcomePage* _tmp27_;
	GraniteToast* _tmp28_;
	GtkOverlay* overlay = NULL;
	AdwNavigationView* _tmp29_;
	GtkWidget* _tmp30_;
	GtkOverlay* _tmp31_ = NULL;
	GtkOverlay* _tmp32_;
	GraniteToast* _tmp33_;
	GtkGrid* _tmp34_ = NULL;
	GtkGrid* _tmp35_;
	GtkOverlay* _tmp36_;
	AudienceServicesLibraryManager* manager = NULL;
	AudienceServicesLibraryManager* _tmp37_;
	AudienceServicesLibraryManager* _tmp38_;
	AudienceLibraryPage* _tmp39_;
	AdwNavigationView* _tmp40_;
	AudiencePlaybackManager* _tmp41_;
	AudiencePlaybackManager* _tmp42_;
	AudiencePlaybackManager* _tmp43_;
	GtkStringList* _tmp44_;
	GtkStringList* _tmp45_;
	AudiencePlaybackManager* _tmp46_;
	GtkEventControllerKey* key_controller = NULL;
	GtkEventControllerKey* _tmp47_;
	GtkOverlay* _tmp48_;
	GtkEventControllerKey* _tmp49_;
	GtkEventController* _tmp50_;
	GtkEventControllerKey* _tmp51_;
	GtkDropTarget* drop_target = NULL;
	GtkDropTarget* _tmp52_;
	AdwNavigationView* _tmp53_;
	GtkDropTarget* _tmp54_;
	GtkEventController* _tmp55_;
	GtkDropTarget* _tmp56_;
#line 64 "../src/Window.vala"
	parent_class = G_OBJECT_CLASS (audience_window_parent_class);
#line 64 "../src/Window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_WINDOW, AudienceWindow);
#line 64 "../src/Window.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 64 "../src/Window.vala"
	_data4_->_ref_count_ = 1;
#line 64 "../src/Window.vala"
	_data4_->self = g_object_ref (self);
#line 65 "../src/Window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, AUDIENCE_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (AUDIENCE_WINDOW_ACTION_ENTRIES), self);
#line 67 "../src/Window.vala"
	_tmp0_ = g_application_get_default ();
#line 67 "../src/Window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 67 "../src/Window.vala"
	application_instance = _tmp1_;
#line 2287 "Window.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 68 "../src/Window.vala"
		_tmp2_ = audience_window_action_accelerators;
#line 68 "../src/Window.vala"
		_tmp3_ = gee_multi_map_get_keys (_tmp2_);
#line 68 "../src/Window.vala"
		_tmp4_ = _tmp3_;
#line 68 "../src/Window.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 68 "../src/Window.vala"
		_tmp6_ = _tmp5_;
#line 68 "../src/Window.vala"
		_g_object_unref0 (_tmp4_);
#line 68 "../src/Window.vala"
		_action_it = _tmp6_;
#line 68 "../src/Window.vala"
		while (TRUE) {
#line 2311 "Window.c"
			GeeIterator* _tmp7_;
			gchar* action = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GtkApplication* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GeeMultiMap* _tmp14_;
			const gchar* _tmp15_;
			GeeCollection* _tmp16_;
			GeeCollection* _tmp17_;
			gint _tmp18_ = 0;
			gpointer* _tmp19_;
			gchar** _tmp20_;
			gint _tmp20__length1;
#line 68 "../src/Window.vala"
			_tmp7_ = _action_it;
#line 68 "../src/Window.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 68 "../src/Window.vala"
				break;
#line 2334 "Window.c"
			}
#line 68 "../src/Window.vala"
			_tmp8_ = _action_it;
#line 68 "../src/Window.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 68 "../src/Window.vala"
			action = (gchar*) _tmp9_;
#line 69 "../src/Window.vala"
			_tmp10_ = application_instance;
#line 69 "../src/Window.vala"
			_tmp11_ = action;
#line 69 "../src/Window.vala"
			_tmp12_ = g_strconcat (AUDIENCE_WINDOW_ACTION_PREFIX, _tmp11_, NULL);
#line 69 "../src/Window.vala"
			_tmp13_ = _tmp12_;
#line 69 "../src/Window.vala"
			_tmp14_ = audience_window_action_accelerators;
#line 69 "../src/Window.vala"
			_tmp15_ = action;
#line 69 "../src/Window.vala"
			_tmp16_ = gee_multi_map_get (_tmp14_, _tmp15_);
#line 69 "../src/Window.vala"
			_tmp17_ = _tmp16_;
#line 69 "../src/Window.vala"
			_tmp19_ = gee_collection_to_array (_tmp17_, &_tmp18_);
#line 69 "../src/Window.vala"
			_tmp20_ = _tmp19_;
#line 69 "../src/Window.vala"
			_tmp20__length1 = _tmp18_;
#line 69 "../src/Window.vala"
			gtk_application_set_accels_for_action (_tmp10_, _tmp13_, _tmp20_);
#line 69 "../src/Window.vala"
			_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/Window.vala"
			_g_object_unref0 (_tmp17_);
#line 69 "../src/Window.vala"
			_g_free0 (_tmp13_);
#line 68 "../src/Window.vala"
			_g_free0 (action);
#line 2374 "Window.c"
		}
#line 68 "../src/Window.vala"
		_g_object_unref0 (_action_it);
#line 2378 "Window.c"
	}
#line 74 "../src/Window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, 1000, 680);
#line 76 "../src/Window.vala"
	_tmp21_ = audience_library_page_get_instance ();
#line 76 "../src/Window.vala"
	_g_object_unref0 (self->priv->library_page);
#line 76 "../src/Window.vala"
	self->priv->library_page = _tmp21_;
#line 78 "../src/Window.vala"
	_tmp22_ = audience_welcome_page_new ();
#line 78 "../src/Window.vala"
	g_object_ref_sink (_tmp22_);
#line 78 "../src/Window.vala"
	_g_object_unref0 (self->priv->welcome_page);
#line 78 "../src/Window.vala"
	self->priv->welcome_page = _tmp22_;
#line 80 "../src/Window.vala"
	_tmp23_ = audience_player_page_new ();
#line 80 "../src/Window.vala"
	g_object_ref_sink (_tmp23_);
#line 80 "../src/Window.vala"
	_g_object_unref0 (self->priv->player_page);
#line 80 "../src/Window.vala"
	self->priv->player_page = _tmp23_;
#line 82 "../src/Window.vala"
	_tmp24_ = audience_episodes_page_new ();
#line 82 "../src/Window.vala"
	g_object_ref_sink (_tmp24_);
#line 82 "../src/Window.vala"
	_g_object_unref0 (self->priv->episodes_page);
#line 82 "../src/Window.vala"
	self->priv->episodes_page = _tmp24_;
#line 84 "../src/Window.vala"
	_tmp25_ = (AdwNavigationView*) adw_navigation_view_new ();
#line 84 "../src/Window.vala"
	g_object_ref_sink (_tmp25_);
#line 84 "../src/Window.vala"
	_g_object_unref0 (self->priv->navigation_view);
#line 84 "../src/Window.vala"
	self->priv->navigation_view = _tmp25_;
#line 85 "../src/Window.vala"
	_tmp26_ = self->priv->navigation_view;
#line 85 "../src/Window.vala"
	_tmp27_ = self->priv->welcome_page;
#line 85 "../src/Window.vala"
	adw_navigation_view_add (_tmp26_, (AdwNavigationPage*) _tmp27_);
#line 87 "../src/Window.vala"
	_tmp28_ = granite_toast_new ("");
#line 87 "../src/Window.vala"
	g_object_ref_sink (_tmp28_);
#line 87 "../src/Window.vala"
	_g_object_unref0 (self->priv->app_notification);
#line 87 "../src/Window.vala"
	self->priv->app_notification = _tmp28_;
#line 89 "../src/Window.vala"
	_tmp29_ = self->priv->navigation_view;
#line 89 "../src/Window.vala"
	_tmp30_ = _g_object_ref0 ((GtkWidget*) _tmp29_);
#line 89 "../src/Window.vala"
	_tmp31_ = (GtkOverlay*) gtk_overlay_new ();
#line 89 "../src/Window.vala"
	gtk_overlay_set_child (_tmp31_, _tmp30_);
#line 89 "../src/Window.vala"
	_g_object_unref0 (_tmp30_);
#line 89 "../src/Window.vala"
	g_object_ref_sink (_tmp31_);
#line 89 "../src/Window.vala"
	overlay = _tmp31_;
#line 92 "../src/Window.vala"
	_tmp32_ = overlay;
#line 92 "../src/Window.vala"
	_tmp33_ = self->priv->app_notification;
#line 92 "../src/Window.vala"
	gtk_overlay_add_overlay (_tmp32_, (GtkWidget*) _tmp33_);
#line 94 "../src/Window.vala"
	_tmp34_ = (GtkGrid*) gtk_grid_new ();
#line 94 "../src/Window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp34_, FALSE);
#line 94 "../src/Window.vala"
	g_object_ref_sink (_tmp34_);
#line 94 "../src/Window.vala"
	_tmp35_ = _tmp34_;
#line 94 "../src/Window.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp35_);
#line 94 "../src/Window.vala"
	_g_object_unref0 (_tmp35_);
#line 97 "../src/Window.vala"
	_tmp36_ = overlay;
#line 97 "../src/Window.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp36_);
#line 98 "../src/Window.vala"
	gtk_window_present ((GtkWindow*) self);
#line 100 "../src/Window.vala"
	_tmp37_ = audience_services_library_manager_get_instance ();
#line 100 "../src/Window.vala"
	manager = _tmp37_;
#line 102 "../src/Window.vala"
	_tmp38_ = manager;
#line 102 "../src/Window.vala"
	g_signal_connect_object (_tmp38_, "media-item-trashed", (GCallback) __audience_window___lambda72__audience_services_library_manager_media_item_trashed, self, 0);
#line 118 "../src/Window.vala"
	_tmp39_ = self->priv->library_page;
#line 118 "../src/Window.vala"
	g_signal_connect_object (_tmp39_, "show-episodes", (GCallback) __audience_window___lambda73__audience_library_page_show_episodes, self, 0);
#line 125 "../src/Window.vala"
	_tmp40_ = self->priv->navigation_view;
#line 125 "../src/Window.vala"
	g_signal_connect_object ((GObject*) _tmp40_, "notify::visible-page", (GCallback) __audience_window___lambda74__g_object_notify, self, 0);
#line 129 "../src/Window.vala"
	_tmp41_ = audience_playback_manager_get_default ();
#line 129 "../src/Window.vala"
	_tmp42_ = _g_object_ref0 (_tmp41_);
#line 129 "../src/Window.vala"
	_data4_->playback_manager = _tmp42_;
#line 131 "../src/Window.vala"
	_tmp43_ = _data4_->playback_manager;
#line 131 "../src/Window.vala"
	_tmp44_ = audience_playback_manager_get_play_queue (_tmp43_);
#line 131 "../src/Window.vala"
	_tmp45_ = _tmp44_;
#line 131 "../src/Window.vala"
	g_signal_connect_data ((GListModel*) _tmp45_, "items-changed", (GCallback) __audience_window___lambda75__g_list_model_items_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 148 "../src/Window.vala"
	_tmp46_ = _data4_->playback_manager;
#line 148 "../src/Window.vala"
	g_signal_connect_object (_tmp46_, "ended", (GCallback) _audience_window_on_player_ended_audience_playback_manager_ended, self, 0);
#line 150 "../src/Window.vala"
	_tmp47_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 150 "../src/Window.vala"
	key_controller = _tmp47_;
#line 151 "../src/Window.vala"
	_tmp48_ = overlay;
#line 151 "../src/Window.vala"
	_tmp49_ = key_controller;
#line 151 "../src/Window.vala"
	_tmp50_ = _g_object_ref0 ((GtkEventController*) _tmp49_);
#line 151 "../src/Window.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp48_, _tmp50_);
#line 152 "../src/Window.vala"
	_tmp51_ = key_controller;
#line 152 "../src/Window.vala"
	g_signal_connect_object (_tmp51_, "key-released", (GCallback) _audience_window_handle_key_press_gtk_event_controller_key_key_released, self, 0);
#line 154 "../src/Window.vala"
	_tmp52_ = gtk_drop_target_new (gdk_file_list_get_type (), GDK_ACTION_COPY);
#line 154 "../src/Window.vala"
	drop_target = _tmp52_;
#line 155 "../src/Window.vala"
	_tmp53_ = self->priv->navigation_view;
#line 155 "../src/Window.vala"
	_tmp54_ = drop_target;
#line 155 "../src/Window.vala"
	_tmp55_ = _g_object_ref0 ((GtkEventController*) _tmp54_);
#line 155 "../src/Window.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp53_, _tmp55_);
#line 156 "../src/Window.vala"
	_tmp56_ = drop_target;
#line 156 "../src/Window.vala"
	g_signal_connect_object (_tmp56_, "drop", (GCallback) __audience_window___lambda76__gtk_drop_target_drop, self, 0);
#line 64 "../src/Window.vala"
	_g_object_unref0 (drop_target);
#line 64 "../src/Window.vala"
	_g_object_unref0 (key_controller);
#line 64 "../src/Window.vala"
	_g_object_unref0 (manager);
#line 64 "../src/Window.vala"
	_g_object_unref0 (overlay);
#line 64 "../src/Window.vala"
	_g_object_unref0 (application_instance);
#line 64 "../src/Window.vala"
	block4_data_unref (_data4_);
#line 64 "../src/Window.vala"
	_data4_ = NULL;
#line 64 "../src/Window.vala"
	return obj;
#line 2554 "Window.c"
}

static void
audience_window_class_init (AudienceWindowClass * klass,
                            gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* _tmp1_;
	GeeMultiMap* _tmp2_;
	GeeMultiMap* _tmp3_;
	GeeMultiMap* _tmp4_;
	GeeMultiMap* _tmp5_;
	GeeMultiMap* _tmp6_;
#line 23 "../src/Window.vala"
	audience_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Window.vala"
	g_type_class_adjust_private_offset (klass, &AudienceWindow_private_offset);
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (klass)->constructor = audience_window_constructor;
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (klass)->finalize = audience_window_finalize;
#line 23 "../src/Window.vala"
	audience_window_signals[AUDIENCE_WINDOW_MEDIA_VOLUMES_CHANGED_SIGNAL] = g_signal_new ("media-volumes-changed", AUDIENCE_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 44 "../src/Window.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 44 "../src/Window.vala"
	audience_window_action_accelerators = (GeeMultiMap*) _tmp0_;
#line 56 "../src/Window.vala"
	_tmp1_ = audience_window_action_accelerators;
#line 56 "../src/Window.vala"
	gee_multi_map_set (_tmp1_, AUDIENCE_WINDOW_ACTION_FULLSCREEN, "F");
#line 57 "../src/Window.vala"
	_tmp2_ = audience_window_action_accelerators;
#line 57 "../src/Window.vala"
	gee_multi_map_set (_tmp2_, AUDIENCE_WINDOW_ACTION_FULLSCREEN, "F11");
#line 58 "../src/Window.vala"
	_tmp3_ = audience_window_action_accelerators;
#line 58 "../src/Window.vala"
	gee_multi_map_set (_tmp3_, AUDIENCE_WINDOW_ACTION_OPEN_FILE, "<Control>O");
#line 59 "../src/Window.vala"
	_tmp4_ = audience_window_action_accelerators;
#line 59 "../src/Window.vala"
	gee_multi_map_set (_tmp4_, AUDIENCE_WINDOW_ACTION_QUIT, "<Control>Q");
#line 60 "../src/Window.vala"
	_tmp5_ = audience_window_action_accelerators;
#line 60 "../src/Window.vala"
	gee_multi_map_set (_tmp5_, AUDIENCE_WINDOW_ACTION_SEARCH, "<Control>F");
#line 61 "../src/Window.vala"
	_tmp6_ = audience_window_action_accelerators;
#line 61 "../src/Window.vala"
	gee_multi_map_set (_tmp6_, AUDIENCE_WINDOW_ACTION_UNDO, "<Control>Z");
#line 2606 "Window.c"
}

static void
audience_window_instance_init (AudienceWindow * self,
                               gpointer klass)
{
#line 23 "../src/Window.vala"
	self->priv = audience_window_get_instance_private (self);
#line 2615 "Window.c"
}

static void
audience_window_finalize (GObject * obj)
{
	AudienceWindow * self;
#line 23 "../src/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_WINDOW, AudienceWindow);
#line 24 "../src/Window.vala"
	_g_object_unref0 (self->priv->navigation_view);
#line 25 "../src/Window.vala"
	_g_object_unref0 (self->priv->app_notification);
#line 26 "../src/Window.vala"
	_g_object_unref0 (self->priv->episodes_page);
#line 27 "../src/Window.vala"
	_g_object_unref0 (self->priv->library_page);
#line 28 "../src/Window.vala"
	_g_object_unref0 (self->priv->player_page);
#line 29 "../src/Window.vala"
	_g_object_unref0 (self->priv->welcome_page);
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (audience_window_parent_class)->finalize (obj);
#line 2638 "Window.c"
}

static GType
audience_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AudienceWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) audience_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AudienceWindow), 0, (GInstanceInitFunc) audience_window_instance_init, NULL };
	GType audience_window_type_id;
	audience_window_type_id = g_type_register_static (gtk_application_window_get_type (), "AudienceWindow", &g_define_type_info, 0);
	AudienceWindow_private_offset = g_type_add_instance_private (audience_window_type_id, sizeof (AudienceWindowPrivate));
	return audience_window_type_id;
}

GType
audience_window_get_type (void)
{
	static volatile gsize audience_window_type_id__once = 0;
	if (g_once_init_enter (&audience_window_type_id__once)) {
		GType audience_window_type_id;
		audience_window_type_id = audience_window_get_type_once ();
		g_once_init_leave (&audience_window_type_id__once, audience_window_type_id);
	}
	return audience_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

